// JavaScript Document

// const { $ } = require("@hapi/joi/lib/base");

$(window).on("load", function () {
  "use strict";

  /*----------------------------------------------------*/
  /*	Preloader
		/*----------------------------------------------------*/

  stopLoader();

  function stopLoader() {
    if (!document.getElementById("loading") || !document.querySelector("#loading .spinner")) {
      setTimeout(function () {
        stopLoader();
      }, 10);
      return;
    }

    var preloader = $(".loading-spinner"),
      loader = preloader.find(".spinner");
    loader.fadeOut();
    preloader.delay(400).fadeOut("slow");
  }
});

$(window).on("scroll", function () {
  "use strict";

  /*----------------------------------------------------*/
  /*	Navigtion Menu Scroll
		/*----------------------------------------------------*/

  var b = $(window).scrollTop();

  if (b > 80) {
    $(".wsmainfull").addClass("scroll");
  } else {
    $(".wsmainfull").removeClass("scroll");
  }
});

$(document).ready(function () {
  "use strict";

  new WOW().init();

  if ($.cookie("allow-cookies") !== "yes") {
    $("#cookie-law-info-bar").css({ display: "flex" });
  } else {
    $("#cookie-law-info-bar").hide();
    $(".footer").css({ "padding-bottom": "0px" });
  }
  $(".cookie_action_close_header").click(function () {
    $("#cookie-law-info-bar").hide();
    $.cookie("allow-cookies", "yes");
    $(".footer").css({ "padding-bottom": "0px" });
  });

  /*----------------------------------------------------*/
  /*	Hero Slider
		/*----------------------------------------------------*/

  $(".slider").slider({
    full_width: false,
    interval: 6000,
    transition: 1000,
    draggable: false,
    indicators: true,
  });

  $(".slide-next").on("click", function () {
    $(".slider").slider("next");
  });

  $(".slide-prev").on("click", function () {
    $(".slider").slider("prev");
  });

  /*----------------------------------------------------*/
  /*	Hero Text Rotator
		/*----------------------------------------------------*/

  $(".hero-txt-rotator").flexslider({
    animation: "fade",
    controlNav: true,
    directionNav: false,
    slideshowSpeed: 6000,
    animationSpeed: 700,
    start: function (slider) {
      $("body").removeClass("loading");
    },
  });

  /*----------------------------------------------------*/
  /*	ScrollUp
		/*----------------------------------------------------*/

  $.scrollUp = function (options) {
    // Defaults
    var defaults = {
      scrollName: "scrollUp", // Element ID
      topDistance: 600, // Distance from top before showing element (px)
      topSpeed: 800, // Speed back to top (ms)
      animation: "fade", // Fade, slide, none
      animationInSpeed: 200, // Animation in speed (ms)
      animationOutSpeed: 200, // Animation out speed (ms)
      scrollText: "", // Text for element
      scrollImg: false, // Set true to use image
      activeOverlay: false, // Set CSS color to display scrollUp active point, e.g '#00FFFF'
    };

    var o = $.extend({}, defaults, options),
      scrollId = "#" + o.scrollName;

    // Create element
    $("<a/>", {
      id: o.scrollName,
      href: "#top",
      title: o.scrollText,
      "aria-label": "scroll top",
    }).appendTo("body");

    // If not using an image display text
    if (!o.scrollImg) {
      $(scrollId).text(o.scrollText);
    }

    // Minium CSS to make the magic happen
    $(scrollId).css({ display: "none", position: "fixed", "z-index": "99999" });

    // Active point overlay
    if (o.activeOverlay) {
      $("body").append("<div id='" + o.scrollName + "-active'></div>");
      $(scrollId + "-active").css({
        position: "absolute",
        top: o.topDistance + "px",
        width: "100%",
        "border-top": "1px dotted " + o.activeOverlay,
        "z-index": "99999",
      });
    }

    // Scroll function
    $(window).on("scroll", function () {
      switch (o.animation) {
        case "fade":
          $($(window).scrollTop() > o.topDistance ? $(scrollId).fadeIn(o.animationInSpeed) : $(scrollId).fadeOut(o.animationOutSpeed));
          break;
        case "slide":
          $($(window).scrollTop() > o.topDistance ? $(scrollId).slideDown(o.animationInSpeed) : $(scrollId).slideUp(o.animationOutSpeed));
          break;
        default:
          $($(window).scrollTop() > o.topDistance ? $(scrollId).show(0) : $(scrollId).hide(0));
      }
    });
  };

  $.scrollUp();

  /*----------------------------------------------------*/
  /*	DateTimePicker
		/*----------------------------------------------------*/

  $("#datetimepicker").datetimepicker();

  /*----------------------------------------------------*/
  /*	Accordion
		/*----------------------------------------------------*/

  $(".accordion > .accordion-item.is-active").children(".accordion-panel").slideDown();

  $(".accordion > .accordion-item").on("click", function () {
    $(this).siblings(".accordion-item").removeClass("is-active").children(".accordion-panel").slideUp();
    $(this).toggleClass("is-active").children(".accordion-panel").slideToggle("ease-out");
  });

  /*----------------------------------------------------*/
  /*	Video Background
		/*----------------------------------------------------*/

  $(".video-play").vide("./images/video/video", {
    posterType: "jpg",
  });

  /*----------------------------------------------------*/
  /*	Masonry Grid
		/*----------------------------------------------------*/

  $(".grid-loaded").imagesLoaded(function () {
    // filter items on button click
    $(".masonry-filter").on("click", "button", function () {
      var filterValue = $(this).attr("data-filter");
      $grid.isotope({
        filter: filterValue,
      });
    });

    // change is-checked class on buttons
    $(".masonry-filter button").on("click", function () {
      $(".masonry-filter button").removeClass("is-checked");
      $(this).addClass("is-checked");
      var selector = $(this).attr("data-filter");
      $grid.isotope({
        filter: selector,
      });
      return false;
    });

    // init Isotope
    var $grid = $(".masonry-wrap").isotope({
      itemSelector: ".masonry-image",
      percentPosition: true,
      transitionDuration: "0.7s",
      masonry: {
        // use outer width of grid-sizer for columnWidth
        columnWidth: ".masonry-image",
      },
    });
  });

  /*----------------------------------------------------*/
  /*	Single Image Lightbox
		/*----------------------------------------------------*/

  $(".image-link").magnificPopup({
    type: "image",
  });

  /*----------------------------------------------------*/
  /*	Video Link #1 Lightbox
		/*----------------------------------------------------*/

  $(".video-popup1").magnificPopup({
    type: "iframe",
    iframe: {
      patterns: {
        youtube: {
          index: "youtube.com",
          src: "https://www.youtube.com/embed/SZEflIVnhH8",
        },
      },
    },
  });

  /*----------------------------------------------------*/
  /*	Video Link #2 Lightbox
		/*----------------------------------------------------*/

  $(".video-popup2").magnificPopup({
    type: "iframe",
    iframe: {
      patterns: {
        youtube: {
          index: "youtube.com",
          src: "https://www.youtube.com/embed/7e90gBu4pas",
        },
      },
    },
  });

  /*----------------------------------------------------*/
  /*	Video Link #3 Lightbox
		/*----------------------------------------------------*/

  $(".video-popup3").magnificPopup({
    type: "iframe",
    iframe: {
      patterns: {
        youtube: {
          index: "youtube.com",
          src: "https://www.youtube.com/embed/0gv7OC9L2s8",
        },
      },
    },
  });

  /*----------------------------------------------------*/
  /*	Testimonials Rotator
		/*----------------------------------------------------*/

  var owl = $(".reviews-wrapper");
  owl.owlCarousel({
    items: 3,
    loop: true,
    autoplay: true,
    navBy: 1,
    autoplayTimeout: 4500,
    autoplayHoverPause: true,
    smartSpeed: 1500,
    responsive: {
      0: {
        items: 1,
      },
      767: {
        items: 1,
      },
      768: {
        items: 2,
      },
      991: {
        items: 3,
      },
      1000: {
        items: 3,
      },
    },
  });

  /*----------------------------------------------------*/
  /*	Reviews Rotator Flexslider
		/*----------------------------------------------------*/

  $("#reviews-2 .flexslider").flexslider({
    animation: "fade",
    controlNav: true,
    directionNav: false,
    slideshowSpeed: 5000,
    animationSpeed: 2000,
    start: function (slider) {
      $("body").removeClass("loading");
    },
  });

  /*----------------------------------------------------*/
  /*	Brands Logo Rotator
		/*----------------------------------------------------*/

  var owl = $(".brands-1-carousel");
  owl.owlCarousel({
    items: 5,
    loop: true,
    autoplay: true,
    navBy: 1,
    nav: false,
    autoplayTimeout: 4000,
    autoplayHoverPause: false,
    smartSpeed: 2000,
    responsive: {
      0: {
        items: 2,
      },
      550: {
        items: 3,
      },
      767: {
        items: 3,
      },
      768: {
        items: 4,
      },
      991: {
        items: 5,
      },
      1000: {
        items: 5,
      },
    },
  });

  /*----------------------------------------------------*/
  /*	Brands Logo Rotator
		/*----------------------------------------------------*/

  var owl = $(".brands-2-carousel");
  owl.owlCarousel({
    items: 5,
    loop: true,
    autoplay: true,
    navBy: 1,
    nav: false,
    autoplayTimeout: 4000,
    autoplayHoverPause: false,
    smartSpeed: 2000,
    responsive: {
      0: {
        items: 2,
      },
      550: {
        items: 3,
      },
      767: {
        items: 3,
      },
      768: {
        items: 4,
      },
      991: {
        items: 4,
      },
      1000: {
        items: 4,
      },
    },
  });

  /*----------------------------------------------------*/
  /*	Booking Form Validation
		/*----------------------------------------------------*/

  $(".booking-form").validate({
    rules: {
      select: "required",
      firstname: "required",
      lastname: "required",
      email: {
        required: true,
        email: true,
      },
      phone: {
        required: true,
        digits: true,
      },
    },
    messages: {
      select: "This field is required",
      firstname: "Please enter your first name",
      lastname: "Please enter your last name",
      email: "We need your email address to contact you",
      phone: "Please enter a valid number",
    },
  });

  /*----------------------------------------------------*/
  /*	Contact Form Validation
		/*----------------------------------------------------*/

  $(".contact-form").validate({
    rules: {
      name: {
        required: true,
        minlength: 1,
        maxlength: 56,
      },
      email: {
        required: true,
        email: true,
      },
      message: {
        required: true,
        minlength: 2,
      },
    },
    messages: {
      name: {
        required: "Please enter no less than (1) characters",
      },
      email: {
        required: "We need your email address to contact you",
        email: "Your email address must be in the format of name@domain.com",
      },
      message: {
        required: "Please enter no less than (2) characters",
      },
    },
  });

  /*----------------------------------------------------*/
  /*	Comment Form Validation
		/*----------------------------------------------------*/

  $(".comment-form").validate({
    rules: {
      name: {
        required: true,
        minlength: 1,
        maxlength: 16,
      },
      email: {
        required: true,
        email: true,
      },
      message: {
        required: true,
        minlength: 2,
      },
    },
    messages: {
      name: {
        required: "Please enter no less than (1) characters",
      },
      email: {
        required: "We need your email address to contact you",
        email: "Your email address must be in the format of name@domain.com",
      },
      message: {
        required: "Please enter no less than (2) characters",
      },
    },
  });

  /*----------------------------------------------------*/
  /*	Newsletter Subscribe Form
		/*----------------------------------------------------*/

  $(".newsletter-form").ajaxChimp({
    language: "cm",
    url: "https://dsathemes.us3.list-manage.com/subscribe/post?u=af1a6c0b23340d7b339c085b4&id=344a494a6e",
    //http://xxx.xxx.list-manage.com/subscribe/post?u=xxx&id=xxx
  });

  $.ajaxChimp.translations.cm = {
    submit: "Submitting...",
    0: "We have sent you a confirmation email",
    1: "Please enter your email address",
    2: "An email address must contain a single @",
    3: "The domain portion of the email address is invalid (the portion after the @: )",
    4: "The username portion of the email address is invalid (the portion before the @: )",
    5: "This email address looks fake or invalid. Please enter a real email address",
  };
});
