/*!
 * @copyright Copyright &copy; Kartik Visweswaran, Krajee.com, 2014 - 2016
 * @version 1.3.4
 *
 * Date formatter utility library that allows formatting date/time variables or Date objects using PHP DateTime format.
 * @see http://php.net/manual/en/function.date.php
 *
 * For more JQuery plugins visit http://plugins.krajee.com
 * For more Yii related demos visit http://demos.krajee.com
 */
var DateFormatter;!function(){"use strict";var t,e,r,n,a,u,i;u=864e5,i=3600,t=function(t,e){return"string"==typeof t&&"string"==typeof e&&t.toLowerCase()===e.toLowerCase()},e=function(t,r,n){var a=n||"0",u=t.toString();return u.length<r?e(a+u,r):u},r=function(t){var e,n;for(t=t||{},e=1;e<arguments.length;e++)if(n=arguments[e])for(var a in n)n.hasOwnProperty(a)&&("object"==typeof n[a]?r(t[a],n[a]):t[a]=n[a]);return t},n=function(t,e){for(var r=0;r<e.length;r++)if(e[r].toLowerCase()===t.toLowerCase())return r;return-1},a={dateSettings:{days:["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"],daysShort:["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],months:["January","February","March","April","May","June","July","August","September","October","November","December"],monthsShort:["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"],meridiem:["AM","PM"],ordinal:function(t){var e=t%10,r={1:"st",2:"nd",3:"rd"};return 1!==Math.floor(t%100/10)&&r[e]?r[e]:"th"}},separators:/[ \-+\/\.T:@]/g,validParts:/[dDjlNSwzWFmMntLoYyaABgGhHisueTIOPZcrU]/g,intParts:/[djwNzmnyYhHgGis]/g,tzParts:/\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[-+]\d{4})?)\b/g,tzClip:/[^-+\dA-Z]/g},(DateFormatter=function(t){var e=this,n=r(a,t);e.dateSettings=n.dateSettings,e.separators=n.separators,e.validParts=n.validParts,e.intParts=n.intParts,e.tzParts=n.tzParts,e.tzClip=n.tzClip}).prototype={constructor:DateFormatter,getMonth:function(t){var e,r=this;return 0===(e=n(t,r.dateSettings.monthsShort)+1)&&(e=n(t,r.dateSettings.months)+1),e},parseDate:function(e,r){var n,a,u,i,s,o,c,f,l,h,d=this,g=!1,m=!1,p=d.dateSettings,y={date:null,year:null,month:null,day:null,hour:0,min:0,sec:0};if(!e)return null;if(e instanceof Date)return e;if("U"===r)return(u=parseInt(e))?new Date(1e3*u):e;switch(typeof e){case"number":return new Date(e);case"string":break;default:return null}if(!(n=r.match(d.validParts))||0===n.length)throw new Error("Invalid date format definition.");for(a=e.replace(d.separators,"\0").split("\0"),u=0;u<a.length;u++)switch(i=a[u],s=parseInt(i),n[u]){case"y":case"Y":if(!s)return null;l=i.length,y.year=2===l?parseInt((70>s?"20":"19")+i):s,g=!0;break;case"m":case"n":case"M":case"F":if(isNaN(s)){if(!((o=d.getMonth(i))>0))return null;y.month=o}else{if(!(s>=1&&12>=s))return null;y.month=s}g=!0;break;case"d":case"j":if(!(s>=1&&31>=s))return null;y.day=s,g=!0;break;case"g":case"h":if(h=a[c=n.indexOf("a")>-1?n.indexOf("a"):n.indexOf("A")>-1?n.indexOf("A"):-1],c>-1)f=t(h,p.meridiem[0])?0:t(h,p.meridiem[1])?12:-1,s>=1&&12>=s&&f>-1?y.hour=s+f-1:s>=0&&23>=s&&(y.hour=s);else{if(!(s>=0&&23>=s))return null;y.hour=s}m=!0;break;case"G":case"H":if(!(s>=0&&23>=s))return null;y.hour=s,m=!0;break;case"i":if(!(s>=0&&59>=s))return null;y.min=s,m=!0;break;case"s":if(!(s>=0&&59>=s))return null;y.sec=s,m=!0}if(!0===g&&y.year&&y.month&&y.day)y.date=new Date(y.year,y.month-1,y.day,y.hour,y.min,y.sec,0);else{if(!0!==m)return null;y.date=new Date(0,0,0,y.hour,y.min,y.sec,0)}return y.date},guessDate:function(t,e){if("string"!=typeof t)return t;var r,n,a,u,i,s,o=this,c=t.replace(o.separators,"\0").split("\0"),f=/^[djmn]/g,l=e.match(o.validParts),h=new Date,d=0;if(!f.test(l[0]))return t;for(a=0;a<c.length;a++){if(d=2,i=c[a],s=parseInt(i.substr(0,2)),isNaN(s))return null;switch(a){case 0:"m"===l[0]||"n"===l[0]?h.setMonth(s-1):h.setDate(s);break;case 1:"m"===l[0]||"n"===l[0]?h.setDate(s):h.setMonth(s-1);break;case 2:if(n=h.getFullYear(),d=4>(r=i.length)?r:4,!(n=parseInt(4>r?n.toString().substr(0,4-r)+i:i.substr(0,4))))return null;h.setFullYear(n);break;case 3:h.setHours(s);break;case 4:h.setMinutes(s);break;case 5:h.setSeconds(s)}(u=i.substr(d)).length>0&&c.splice(a+1,0,u)}return h},parseFormat:function(t,r){var n,a=this,s=a.dateSettings,o=/\\?(.?)/gi,c=function(t,e){return n[t]?n[t]():e};return n={d:function(){return e(n.j(),2)},D:function(){return s.daysShort[n.w()]},j:function(){return r.getDate()},l:function(){return s.days[n.w()]},N:function(){return n.w()||7},w:function(){return r.getDay()},z:function(){var t=new Date(n.Y(),n.n()-1,n.j()),e=new Date(n.Y(),0,1);return Math.round((t-e)/u)},W:function(){var t=new Date(n.Y(),n.n()-1,n.j()-n.N()+3),r=new Date(t.getFullYear(),0,4);return e(1+Math.round((t-r)/u/7),2)},F:function(){return s.months[r.getMonth()]},m:function(){return e(n.n(),2)},M:function(){return s.monthsShort[r.getMonth()]},n:function(){return r.getMonth()+1},t:function(){return new Date(n.Y(),n.n(),0).getDate()},L:function(){var t=n.Y();return t%4==0&&t%100!=0||t%400==0?1:0},o:function(){var t=n.n(),e=n.W(),r;return n.Y()+(12===t&&9>e?1:1===t&&e>9?-1:0)},Y:function(){return r.getFullYear()},y:function(){return n.Y().toString().slice(-2)},a:function(){return n.A().toLowerCase()},A:function(){var t=n.G()<12?0:1;return s.meridiem[t]},B:function(){var t=r.getUTCHours()*i,n=60*r.getUTCMinutes(),a=r.getUTCSeconds();return e(Math.floor((t+n+a+i)/86.4)%1e3,3)},g:function(){return n.G()%12||12},G:function(){return r.getHours()},h:function(){return e(n.g(),2)},H:function(){return e(n.G(),2)},i:function(){return e(r.getMinutes(),2)},s:function(){return e(r.getSeconds(),2)},u:function(){return e(1e3*r.getMilliseconds(),6)},e:function(){var t;return/\((.*)\)/.exec(String(r))[1]||"Coordinated Universal Time"},I:function(){var t,e,r,a;return new Date(n.Y(),0)-Date.UTC(n.Y(),0)!=new Date(n.Y(),6)-Date.UTC(n.Y(),6)?1:0},O:function(){var t=r.getTimezoneOffset(),n=Math.abs(t);return(t>0?"-":"+")+e(100*Math.floor(n/60)+n%60,4)},P:function(){var t=n.O();return t.substr(0,3)+":"+t.substr(3,2)},T:function(){var t;return(String(r).match(a.tzParts)||[""]).pop().replace(a.tzClip,"")||"UTC"},Z:function(){return 60*-r.getTimezoneOffset()},c:function(){return"Y-m-d\\TH:i:sP".replace(o,c)},r:function(){return"D, d M Y H:i:s O".replace(o,c)},U:function(){return r.getTime()/1e3||0}},c(t,t)},formatDate:function(t,e){var r,n,a,u,i,s=this,o="",c="\\";if("string"==typeof t&&!(t=s.parseDate(t,e)))return null;if(t instanceof Date){for(a=e.length,r=0;a>r;r++)"S"!==(i=e.charAt(r))&&i!==c&&(r>0&&e.charAt(r-1)===c?o+=i:(u=s.parseFormat(i,t),r!==a-1&&s.intParts.test(i)&&"S"===e.charAt(r+1)&&(n=parseInt(u)||0,u+=s.dateSettings.ordinal(n)),o+=u));return o}return""}}}();
/**
 * @preserve jQuery DateTimePicker
 * @homepage http://xdsoft.net/jqplugins/datetimepicker/
 * @author Chupurnov Valeriy (<chupurnov@gmail.com>)
 */
var datetimepickerFactory=function($){"use strict";var default_options={i18n:{ar:{months:["كانون الثاني","شباط","آذار","نيسان","مايو","حزيران","تموز","آب","أيلول","تشرين الأول","تشرين الثاني","كانون الأول"],dayOfWeekShort:["ن","ث","ع","خ","ج","س","ح"],dayOfWeek:["الأحد","الاثنين","الثلاثاء","الأربعاء","الخميس","الجمعة","السبت","الأحد"]},ro:{months:["Ianuarie","Februarie","Martie","Aprilie","Mai","Iunie","Iulie","August","Septembrie","Octombrie","Noiembrie","Decembrie"],dayOfWeekShort:["Du","Lu","Ma","Mi","Jo","Vi","Sâ"],dayOfWeek:["Duminică","Luni","Marţi","Miercuri","Joi","Vineri","Sâmbătă"]},id:{months:["Januari","Februari","Maret","April","Mei","Juni","Juli","Agustus","September","Oktober","November","Desember"],dayOfWeekShort:["Min","Sen","Sel","Rab","Kam","Jum","Sab"],dayOfWeek:["Minggu","Senin","Selasa","Rabu","Kamis","Jumat","Sabtu"]},is:{months:["Janúar","Febrúar","Mars","Apríl","Maí","Júní","Júlí","Ágúst","September","Október","Nóvember","Desember"],dayOfWeekShort:["Sun","Mán","Þrið","Mið","Fim","Fös","Lau"],dayOfWeek:["Sunnudagur","Mánudagur","Þriðjudagur","Miðvikudagur","Fimmtudagur","Föstudagur","Laugardagur"]},bg:{months:["Януари","Февруари","Март","Април","Май","Юни","Юли","Август","Септември","Октомври","Ноември","Декември"],dayOfWeekShort:["Нд","Пн","Вт","Ср","Чт","Пт","Сб"],dayOfWeek:["Неделя","Понеделник","Вторник","Сряда","Четвъртък","Петък","Събота"]},fa:{months:["فروردین","اردیبهشت","خرداد","تیر","مرداد","شهریور","مهر","آبان","آذر","دی","بهمن","اسفند"],dayOfWeekShort:["یکشنبه","دوشنبه","سه شنبه","چهارشنبه","پنجشنبه","جمعه","شنبه"],dayOfWeek:["یک‌شنبه","دوشنبه","سه‌شنبه","چهارشنبه","پنج‌شنبه","جمعه","شنبه","یک‌شنبه"]},ru:{months:["Январь","Февраль","Март","Апрель","Май","Июнь","Июль","Август","Сентябрь","Октябрь","Ноябрь","Декабрь"],dayOfWeekShort:["Вс","Пн","Вт","Ср","Чт","Пт","Сб"],dayOfWeek:["Воскресенье","Понедельник","Вторник","Среда","Четверг","Пятница","Суббота"]},uk:{months:["Січень","Лютий","Березень","Квітень","Травень","Червень","Липень","Серпень","Вересень","Жовтень","Листопад","Грудень"],dayOfWeekShort:["Ндл","Пнд","Втр","Срд","Чтв","Птн","Сбт"],dayOfWeek:["Неділя","Понеділок","Вівторок","Середа","Четвер","П'ятниця","Субота"]},en:{months:["January","February","March","April","May","June","July","August","September","October","November","December"],dayOfWeekShort:["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],dayOfWeek:["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"]},el:{months:["Ιανουάριος","Φεβρουάριος","Μάρτιος","Απρίλιος","Μάιος","Ιούνιος","Ιούλιος","Αύγουστος","Σεπτέμβριος","Οκτώβριος","Νοέμβριος","Δεκέμβριος"],dayOfWeekShort:["Κυρ","Δευ","Τρι","Τετ","Πεμ","Παρ","Σαβ"],dayOfWeek:["Κυριακή","Δευτέρα","Τρίτη","Τετάρτη","Πέμπτη","Παρασκευή","Σάββατο"]},de:{months:["Januar","Februar","März","April","Mai","Juni","Juli","August","September","Oktober","November","Dezember"],dayOfWeekShort:["So","Mo","Di","Mi","Do","Fr","Sa"],dayOfWeek:["Sonntag","Montag","Dienstag","Mittwoch","Donnerstag","Freitag","Samstag"]},nl:{months:["januari","februari","maart","april","mei","juni","juli","augustus","september","oktober","november","december"],dayOfWeekShort:["zo","ma","di","wo","do","vr","za"],dayOfWeek:["zondag","maandag","dinsdag","woensdag","donderdag","vrijdag","zaterdag"]},tr:{months:["Ocak","Şubat","Mart","Nisan","Mayıs","Haziran","Temmuz","Ağustos","Eylül","Ekim","Kasım","Aralık"],dayOfWeekShort:["Paz","Pts","Sal","Çar","Per","Cum","Cts"],dayOfWeek:["Pazar","Pazartesi","Salı","Çarşamba","Perşembe","Cuma","Cumartesi"]},fr:{months:["Janvier","Février","Mars","Avril","Mai","Juin","Juillet","Août","Septembre","Octobre","Novembre","Décembre"],dayOfWeekShort:["Dim","Lun","Mar","Mer","Jeu","Ven","Sam"],dayOfWeek:["dimanche","lundi","mardi","mercredi","jeudi","vendredi","samedi"]},es:{months:["Enero","Febrero","Marzo","Abril","Mayo","Junio","Julio","Agosto","Septiembre","Octubre","Noviembre","Diciembre"],dayOfWeekShort:["Dom","Lun","Mar","Mié","Jue","Vie","Sáb"],dayOfWeek:["Domingo","Lunes","Martes","Miércoles","Jueves","Viernes","Sábado"]},th:{months:["มกราคม","กุมภาพันธ์","มีนาคม","เมษายน","พฤษภาคม","มิถุนายน","กรกฎาคม","สิงหาคม","กันยายน","ตุลาคม","พฤศจิกายน","ธันวาคม"],dayOfWeekShort:["อา.","จ.","อ.","พ.","พฤ.","ศ.","ส."],dayOfWeek:["อาทิตย์","จันทร์","อังคาร","พุธ","พฤหัส","ศุกร์","เสาร์","อาทิตย์"]},pl:{months:["styczeń","luty","marzec","kwiecień","maj","czerwiec","lipiec","sierpień","wrzesień","październik","listopad","grudzień"],dayOfWeekShort:["nd","pn","wt","śr","cz","pt","sb"],dayOfWeek:["niedziela","poniedziałek","wtorek","środa","czwartek","piątek","sobota"]},pt:{months:["Janeiro","Fevereiro","Março","Abril","Maio","Junho","Julho","Agosto","Setembro","Outubro","Novembro","Dezembro"],dayOfWeekShort:["Dom","Seg","Ter","Qua","Qui","Sex","Sab"],dayOfWeek:["Domingo","Segunda","Terça","Quarta","Quinta","Sexta","Sábado"]},ch:{months:["一月","二月","三月","四月","五月","六月","七月","八月","九月","十月","十一月","十二月"],dayOfWeekShort:["日","一","二","三","四","五","六"]},se:{months:["Januari","Februari","Mars","April","Maj","Juni","Juli","Augusti","September","Oktober","November","December"],dayOfWeekShort:["Sön","Mån","Tis","Ons","Tor","Fre","Lör"]},km:{months:["មករា​","កុម្ភៈ","មិនា​","មេសា​","ឧសភា​","មិថុនា​","កក្កដា​","សីហា​","កញ្ញា​","តុលា​","វិច្ឆិកា","ធ្នូ​"],dayOfWeekShort:["អាទិ​","ច័ន្ទ​","អង្គារ​","ពុធ​","ព្រហ​​","សុក្រ​","សៅរ៍"],dayOfWeek:["អាទិត្យ​","ច័ន្ទ​","អង្គារ​","ពុធ​","ព្រហស្បតិ៍​","សុក្រ​","សៅរ៍"]},kr:{months:["1월","2월","3월","4월","5월","6월","7월","8월","9월","10월","11월","12월"],dayOfWeekShort:["일","월","화","수","목","금","토"],dayOfWeek:["일요일","월요일","화요일","수요일","목요일","금요일","토요일"]},it:{months:["Gennaio","Febbraio","Marzo","Aprile","Maggio","Giugno","Luglio","Agosto","Settembre","Ottobre","Novembre","Dicembre"],dayOfWeekShort:["Dom","Lun","Mar","Mer","Gio","Ven","Sab"],dayOfWeek:["Domenica","Lunedì","Martedì","Mercoledì","Giovedì","Venerdì","Sabato"]},da:{months:["Januar","Februar","Marts","April","Maj","Juni","Juli","August","September","Oktober","November","December"],dayOfWeekShort:["Søn","Man","Tir","Ons","Tor","Fre","Lør"],dayOfWeek:["søndag","mandag","tirsdag","onsdag","torsdag","fredag","lørdag"]},no:{months:["Januar","Februar","Mars","April","Mai","Juni","Juli","August","September","Oktober","November","Desember"],dayOfWeekShort:["Søn","Man","Tir","Ons","Tor","Fre","Lør"],dayOfWeek:["Søndag","Mandag","Tirsdag","Onsdag","Torsdag","Fredag","Lørdag"]},ja:{months:["1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"],dayOfWeekShort:["日","月","火","水","木","金","土"],dayOfWeek:["日曜","月曜","火曜","水曜","木曜","金曜","土曜"]},vi:{months:["Tháng 1","Tháng 2","Tháng 3","Tháng 4","Tháng 5","Tháng 6","Tháng 7","Tháng 8","Tháng 9","Tháng 10","Tháng 11","Tháng 12"],dayOfWeekShort:["CN","T2","T3","T4","T5","T6","T7"],dayOfWeek:["Chủ nhật","Thứ hai","Thứ ba","Thứ tư","Thứ năm","Thứ sáu","Thứ bảy"]},sl:{months:["Januar","Februar","Marec","April","Maj","Junij","Julij","Avgust","September","Oktober","November","December"],dayOfWeekShort:["Ned","Pon","Tor","Sre","Čet","Pet","Sob"],dayOfWeek:["Nedelja","Ponedeljek","Torek","Sreda","Četrtek","Petek","Sobota"]},cs:{months:["Leden","Únor","Březen","Duben","Květen","Červen","Červenec","Srpen","Září","Říjen","Listopad","Prosinec"],dayOfWeekShort:["Ne","Po","Út","St","Čt","Pá","So"]},hu:{months:["Január","Február","Március","Április","Május","Június","Július","Augusztus","Szeptember","Október","November","December"],dayOfWeekShort:["Va","Hé","Ke","Sze","Cs","Pé","Szo"],dayOfWeek:["vasárnap","hétfő","kedd","szerda","csütörtök","péntek","szombat"]},az:{months:["Yanvar","Fevral","Mart","Aprel","May","Iyun","Iyul","Avqust","Sentyabr","Oktyabr","Noyabr","Dekabr"],dayOfWeekShort:["B","Be","Ça","Ç","Ca","C","Ş"],dayOfWeek:["Bazar","Bazar ertəsi","Çərşənbə axşamı","Çərşənbə","Cümə axşamı","Cümə","Şənbə"]},bs:{months:["Januar","Februar","Mart","April","Maj","Jun","Jul","Avgust","Septembar","Oktobar","Novembar","Decembar"],dayOfWeekShort:["Ned","Pon","Uto","Sri","Čet","Pet","Sub"],dayOfWeek:["Nedjelja","Ponedjeljak","Utorak","Srijeda","Četvrtak","Petak","Subota"]},ca:{months:["Gener","Febrer","Març","Abril","Maig","Juny","Juliol","Agost","Setembre","Octubre","Novembre","Desembre"],dayOfWeekShort:["Dg","Dl","Dt","Dc","Dj","Dv","Ds"],dayOfWeek:["Diumenge","Dilluns","Dimarts","Dimecres","Dijous","Divendres","Dissabte"]},"en-GB":{months:["January","February","March","April","May","June","July","August","September","October","November","December"],dayOfWeekShort:["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],dayOfWeek:["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"]},et:{months:["Jaanuar","Veebruar","Märts","Aprill","Mai","Juuni","Juuli","August","September","Oktoober","November","Detsember"],dayOfWeekShort:["P","E","T","K","N","R","L"],dayOfWeek:["Pühapäev","Esmaspäev","Teisipäev","Kolmapäev","Neljapäev","Reede","Laupäev"]},eu:{months:["Urtarrila","Otsaila","Martxoa","Apirila","Maiatza","Ekaina","Uztaila","Abuztua","Iraila","Urria","Azaroa","Abendua"],dayOfWeekShort:["Ig.","Al.","Ar.","Az.","Og.","Or.","La."],dayOfWeek:["Igandea","Astelehena","Asteartea","Asteazkena","Osteguna","Ostirala","Larunbata"]},fi:{months:["Tammikuu","Helmikuu","Maaliskuu","Huhtikuu","Toukokuu","Kesäkuu","Heinäkuu","Elokuu","Syyskuu","Lokakuu","Marraskuu","Joulukuu"],dayOfWeekShort:["Su","Ma","Ti","Ke","To","Pe","La"],dayOfWeek:["sunnuntai","maanantai","tiistai","keskiviikko","torstai","perjantai","lauantai"]},gl:{months:["Xan","Feb","Maz","Abr","Mai","Xun","Xul","Ago","Set","Out","Nov","Dec"],dayOfWeekShort:["Dom","Lun","Mar","Mer","Xov","Ven","Sab"],dayOfWeek:["Domingo","Luns","Martes","Mércores","Xoves","Venres","Sábado"]},hr:{months:["Siječanj","Veljača","Ožujak","Travanj","Svibanj","Lipanj","Srpanj","Kolovoz","Rujan","Listopad","Studeni","Prosinac"],dayOfWeekShort:["Ned","Pon","Uto","Sri","Čet","Pet","Sub"],dayOfWeek:["Nedjelja","Ponedjeljak","Utorak","Srijeda","Četvrtak","Petak","Subota"]},ko:{months:["1월","2월","3월","4월","5월","6월","7월","8월","9월","10월","11월","12월"],dayOfWeekShort:["일","월","화","수","목","금","토"],dayOfWeek:["일요일","월요일","화요일","수요일","목요일","금요일","토요일"]},lt:{months:["Sausio","Vasario","Kovo","Balandžio","Gegužės","Birželio","Liepos","Rugpjūčio","Rugsėjo","Spalio","Lapkričio","Gruodžio"],dayOfWeekShort:["Sek","Pir","Ant","Tre","Ket","Pen","Šeš"],dayOfWeek:["Sekmadienis","Pirmadienis","Antradienis","Trečiadienis","Ketvirtadienis","Penktadienis","Šeštadienis"]},lv:{months:["Janvāris","Februāris","Marts","Aprīlis ","Maijs","Jūnijs","Jūlijs","Augusts","Septembris","Oktobris","Novembris","Decembris"],dayOfWeekShort:["Sv","Pr","Ot","Tr","Ct","Pk","St"],dayOfWeek:["Svētdiena","Pirmdiena","Otrdiena","Trešdiena","Ceturtdiena","Piektdiena","Sestdiena"]},mk:{months:["јануари","февруари","март","април","мај","јуни","јули","август","септември","октомври","ноември","декември"],dayOfWeekShort:["нед","пон","вто","сре","чет","пет","саб"],dayOfWeek:["Недела","Понеделник","Вторник","Среда","Четврток","Петок","Сабота"]},mn:{months:["1-р сар","2-р сар","3-р сар","4-р сар","5-р сар","6-р сар","7-р сар","8-р сар","9-р сар","10-р сар","11-р сар","12-р сар"],dayOfWeekShort:["Дав","Мяг","Лха","Пүр","Бсн","Бям","Ням"],dayOfWeek:["Даваа","Мягмар","Лхагва","Пүрэв","Баасан","Бямба","Ням"]},"pt-BR":{months:["Janeiro","Fevereiro","Março","Abril","Maio","Junho","Julho","Agosto","Setembro","Outubro","Novembro","Dezembro"],dayOfWeekShort:["Dom","Seg","Ter","Qua","Qui","Sex","Sáb"],dayOfWeek:["Domingo","Segunda","Terça","Quarta","Quinta","Sexta","Sábado"]},sk:{months:["Január","Február","Marec","Apríl","Máj","Jún","Júl","August","September","Október","November","December"],dayOfWeekShort:["Ne","Po","Ut","St","Št","Pi","So"],dayOfWeek:["Nedeľa","Pondelok","Utorok","Streda","Štvrtok","Piatok","Sobota"]},sq:{months:["Janar","Shkurt","Mars","Prill","Maj","Qershor","Korrik","Gusht","Shtator","Tetor","Nëntor","Dhjetor"],dayOfWeekShort:["Die","Hën","Mar","Mër","Enj","Pre","Shtu"],dayOfWeek:["E Diel","E Hënë","E Martē","E Mërkurë","E Enjte","E Premte","E Shtunë"]},"sr-YU":{months:["Januar","Februar","Mart","April","Maj","Jun","Jul","Avgust","Septembar","Oktobar","Novembar","Decembar"],dayOfWeekShort:["Ned","Pon","Uto","Sre","čet","Pet","Sub"],dayOfWeek:["Nedelja","Ponedeljak","Utorak","Sreda","Četvrtak","Petak","Subota"]},sr:{months:["јануар","фебруар","март","април","мај","јун","јул","август","септембар","октобар","новембар","децембар"],dayOfWeekShort:["нед","пон","уто","сре","чет","пет","суб"],dayOfWeek:["Недеља","Понедељак","Уторак","Среда","Четвртак","Петак","Субота"]},sv:{months:["Januari","Februari","Mars","April","Maj","Juni","Juli","Augusti","September","Oktober","November","December"],dayOfWeekShort:["Sön","Mån","Tis","Ons","Tor","Fre","Lör"],dayOfWeek:["Söndag","Måndag","Tisdag","Onsdag","Torsdag","Fredag","Lördag"]},"zh-TW":{months:["一月","二月","三月","四月","五月","六月","七月","八月","九月","十月","十一月","十二月"],dayOfWeekShort:["日","一","二","三","四","五","六"],dayOfWeek:["星期日","星期一","星期二","星期三","星期四","星期五","星期六"]},zh:{months:["一月","二月","三月","四月","五月","六月","七月","八月","九月","十月","十一月","十二月"],dayOfWeekShort:["日","一","二","三","四","五","六"],dayOfWeek:["星期日","星期一","星期二","星期三","星期四","星期五","星期六"]},ug:{months:["1-ئاي","2-ئاي","3-ئاي","4-ئاي","5-ئاي","6-ئاي","7-ئاي","8-ئاي","9-ئاي","10-ئاي","11-ئاي","12-ئاي"],dayOfWeek:["يەكشەنبە","دۈشەنبە","سەيشەنبە","چارشەنبە","پەيشەنبە","جۈمە","شەنبە"]},he:{months:["ינואר","פברואר","מרץ","אפריל","מאי","יוני","יולי","אוגוסט","ספטמבר","אוקטובר","נובמבר","דצמבר"],dayOfWeekShort:["א'","ב'","ג'","ד'","ה'","ו'","שבת"],dayOfWeek:["ראשון","שני","שלישי","רביעי","חמישי","שישי","שבת","ראשון"]},hy:{months:["Հունվար","Փետրվար","Մարտ","Ապրիլ","Մայիս","Հունիս","Հուլիս","Օգոստոս","Սեպտեմբեր","Հոկտեմբեր","Նոյեմբեր","Դեկտեմբեր"],dayOfWeekShort:["Կի","Երկ","Երք","Չոր","Հնգ","Ուրբ","Շբթ"],dayOfWeek:["Կիրակի","Երկուշաբթի","Երեքշաբթի","Չորեքշաբթի","Հինգշաբթի","Ուրբաթ","Շաբաթ"]},kg:{months:["Үчтүн айы","Бирдин айы","Жалган Куран","Чын Куран","Бугу","Кулжа","Теке","Баш Оона","Аяк Оона","Тогуздун айы","Жетинин айы","Бештин айы"],dayOfWeekShort:["Жек","Дүй","Шей","Шар","Бей","Жум","Ише"],dayOfWeek:["Жекшемб","Дүйшөмб","Шейшемб","Шаршемб","Бейшемби","Жума","Ишенб"]},rm:{months:["Schaner","Favrer","Mars","Avrigl","Matg","Zercladur","Fanadur","Avust","Settember","October","November","December"],dayOfWeekShort:["Du","Gli","Ma","Me","Gie","Ve","So"],dayOfWeek:["Dumengia","Glindesdi","Mardi","Mesemna","Gievgia","Venderdi","Sonda"]},ka:{months:["იანვარი","თებერვალი","მარტი","აპრილი","მაისი","ივნისი","ივლისი","აგვისტო","სექტემბერი","ოქტომბერი","ნოემბერი","დეკემბერი"],dayOfWeekShort:["კვ","ორშ","სამშ","ოთხ","ხუთ","პარ","შაბ"],dayOfWeek:["კვირა","ორშაბათი","სამშაბათი","ოთხშაბათი","ხუთშაბათი","პარასკევი","შაბათი"]}},ownerDocument:document,contentWindow:window,value:"",rtl:!1,format:"Y/m/d H:i",formatTime:"H:i",formatDate:"Y/m/d",startDate:!1,step:60,monthChangeSpinner:!0,closeOnDateSelect:!1,closeOnTimeSelect:!0,closeOnWithoutClick:!0,closeOnInputClick:!0,openOnFocus:!0,timepicker:!0,datepicker:!0,weeks:!1,defaultTime:!1,defaultDate:!1,minDate:!1,maxDate:!1,minTime:!1,maxTime:!1,minDateTime:!1,maxDateTime:!1,allowTimes:[],opened:!1,initTime:!0,inline:!1,theme:"",touchMovedThreshold:5,onSelectDate:function(){},onSelectTime:function(){},onChangeMonth:function(){},onGetWeekOfYear:function(){},onChangeYear:function(){},onChangeDateTime:function(){},onShow:function(){},onClose:function(){},onGenerate:function(){},withoutCopyright:!0,inverseButton:!1,hours12:!1,next:"xdsoft_next",prev:"xdsoft_prev",dayOfWeekStart:0,parentID:"body",timeHeightInTimePicker:25,timepickerScrollbar:!0,todayButton:!0,prevButton:!0,nextButton:!0,defaultSelect:!0,scrollMonth:!0,scrollTime:!0,scrollInput:!0,lazyInit:!1,mask:!1,validateOnBlur:!0,allowBlank:!0,yearStart:1950,yearEnd:2050,monthStart:0,monthEnd:11,style:"",id:"",fixed:!1,roundTime:"round",className:"",weekends:[],highlightedDates:[],highlightedPeriods:[],allowDates:[],allowDateRe:null,disabledDates:[],disabledWeekDays:[],yearOffset:0,beforeShowDay:null,enterLikeTab:!0,showApplyButton:!1,insideParent:!1},dateHelper=null,defaultDateHelper=null,globalLocaleDefault="en",globalLocale="en",dateFormatterOptionsDefault={meridiem:["AM","PM"]},initDateFormatter=function(){var locale=default_options.i18n[globalLocale],opts={days:locale.dayOfWeek,daysShort:locale.dayOfWeekShort,months:locale.months,monthsShort:$.map(locale.months,(function(n){return n.substring(0,3)}))};"function"==typeof DateFormatter&&(dateHelper=defaultDateHelper=new DateFormatter({dateSettings:$.extend({},dateFormatterOptionsDefault,opts)}))},dateFormatters={moment:{default_options:{format:"YYYY/MM/DD HH:mm",formatDate:"YYYY/MM/DD",formatTime:"HH:mm"},formatter:{parseDate:function(date,format){if(isFormatStandard(format))return defaultDateHelper.parseDate(date,format);var d=moment(date,format);return!!d.isValid()&&d.toDate()},formatDate:function(date,format){return isFormatStandard(format)?defaultDateHelper.formatDate(date,format):moment(date).format(format)},formatMask:function(format){return format.replace(/Y{4}/g,"9999").replace(/Y{2}/g,"99").replace(/M{2}/g,"19").replace(/D{2}/g,"39").replace(/H{2}/g,"29").replace(/m{2}/g,"59").replace(/s{2}/g,"59")}}}};$.datetimepicker={setLocale:function(locale){var newLocale=default_options.i18n[locale]?locale:"en";globalLocale!==newLocale&&(globalLocale=newLocale,initDateFormatter())},setDateFormatter:function(dateFormatter){if("string"==typeof dateFormatter&&dateFormatters.hasOwnProperty(dateFormatter)){var df=dateFormatters[dateFormatter];$.extend(default_options,df.default_options),dateHelper=df.formatter}else dateHelper=dateFormatter}};var standardFormats={RFC_2822:"D, d M Y H:i:s O",ATOM:"Y-m-dTH:i:sP",ISO_8601:"Y-m-dTH:i:sO",RFC_822:"D, d M y H:i:s O",RFC_850:"l, d-M-y H:i:s T",RFC_1036:"D, d M y H:i:s O",RFC_1123:"D, d M Y H:i:s O",RSS:"D, d M Y H:i:s O",W3C:"Y-m-dTH:i:sP"},isFormatStandard=function(format){return-1!==Object.values(standardFormats).indexOf(format)};function HighlightedDate(date,desc,style){this.date=date,this.desc=desc,this.style=style}$.extend($.datetimepicker,standardFormats),initDateFormatter(),window.getComputedStyle||(window.getComputedStyle=function(el){return this.el=el,this.getPropertyValue=function(prop){var re=/(-([a-z]))/g;return"float"===prop&&(prop="styleFloat"),re.test(prop)&&(prop=prop.replace(re,(function(a,b,c){return c.toUpperCase()}))),el.currentStyle[prop]||null},this}),Array.prototype.indexOf||(Array.prototype.indexOf=function(obj,start){var i,j;for(i=start||0,j=this.length;i<j;i+=1)if(this[i]===obj)return i;return-1}),Date.prototype.countDaysInMonth=function(){return new Date(this.getFullYear(),this.getMonth()+1,0).getDate()},$.fn.xdsoftScroller=function(options,percent){return this.each((function(){var timeboxparent=$(this),pointerEventToXY=function(e){var out={x:0,y:0},touch;return"touchstart"===e.type||"touchmove"===e.type||"touchend"===e.type||"touchcancel"===e.type?(touch=e.originalEvent.touches[0]||e.originalEvent.changedTouches[0],out.x=touch.clientX,out.y=touch.clientY):"mousedown"!==e.type&&"mouseup"!==e.type&&"mousemove"!==e.type&&"mouseover"!==e.type&&"mouseout"!==e.type&&"mouseenter"!==e.type&&"mouseleave"!==e.type||(out.x=e.clientX,out.y=e.clientY),out},timebox,parentHeight,height,scrollbar,scroller,maximumOffset=100,start=!1,startY=0,startTop=0,h1=0,touchStart=!1,startTopScroll=0,calcOffset=function(){};"hide"!==percent?($(this).hasClass("xdsoft_scroller_box")||(timebox=timeboxparent.children().eq(0),parentHeight=timeboxparent[0].clientHeight,height=timebox[0].offsetHeight,scrollbar=$('<div class="xdsoft_scrollbar"></div>'),scroller=$('<div class="xdsoft_scroller"></div>'),scrollbar.append(scroller),timeboxparent.addClass("xdsoft_scroller_box").append(scrollbar),calcOffset=function calcOffset(event){var offset=pointerEventToXY(event).y-startY+startTopScroll;offset<0&&(offset=0),offset+scroller[0].offsetHeight>h1&&(offset=h1-scroller[0].offsetHeight),timeboxparent.trigger("scroll_element.xdsoft_scroller",[maximumOffset?offset/maximumOffset:0])},scroller.on("touchstart.xdsoft_scroller mousedown.xdsoft_scroller",(function(event){parentHeight||timeboxparent.trigger("resize_scroll.xdsoft_scroller",[percent]),startY=pointerEventToXY(event).y,startTopScroll=parseInt(scroller.css("margin-top"),10),h1=scrollbar[0].offsetHeight,"mousedown"===event.type||"touchstart"===event.type?(options.ownerDocument&&$(options.ownerDocument.body).addClass("xdsoft_noselect"),$([options.ownerDocument.body,options.contentWindow]).on("touchend mouseup.xdsoft_scroller",(function arguments_callee(){$([options.ownerDocument.body,options.contentWindow]).off("touchend mouseup.xdsoft_scroller",arguments_callee).off("mousemove.xdsoft_scroller",calcOffset).removeClass("xdsoft_noselect")})),$(options.ownerDocument.body).on("mousemove.xdsoft_scroller",calcOffset)):(touchStart=!0,event.stopPropagation(),event.preventDefault())})).on("touchmove",(function(event){touchStart&&(event.preventDefault(),calcOffset(event))})).on("touchend touchcancel",(function(){touchStart=!1,startTopScroll=0})),timeboxparent.on("scroll_element.xdsoft_scroller",(function(event,percentage){parentHeight||timeboxparent.trigger("resize_scroll.xdsoft_scroller",[percentage,!0]),percentage=percentage>1?1:percentage<0||isNaN(percentage)?0:percentage,scroller.css("margin-top",maximumOffset*percentage),setTimeout((function(){timebox.css("marginTop",-parseInt((timebox[0].offsetHeight-parentHeight)*percentage,10))}),10)})).on("resize_scroll.xdsoft_scroller",(function(event,percentage,noTriggerScroll){var percent,sh;parentHeight=timeboxparent[0].clientHeight,height=timebox[0].offsetHeight,sh=(percent=parentHeight/height)*scrollbar[0].offsetHeight,percent>1?scroller.hide():(scroller.show(),scroller.css("height",parseInt(sh>10?sh:10,10)),maximumOffset=scrollbar[0].offsetHeight-scroller[0].offsetHeight,!0!==noTriggerScroll&&timeboxparent.trigger("scroll_element.xdsoft_scroller",[percentage||Math.abs(parseInt(timebox.css("marginTop"),10))/(height-parentHeight)]))})),timeboxparent.on("mousewheel",(function(event){var top=Math.abs(parseInt(timebox.css("marginTop"),10));return(top-=20*event.deltaY)<0&&(top=0),timeboxparent.trigger("scroll_element.xdsoft_scroller",[top/(height-parentHeight)]),event.stopPropagation(),!1})),timeboxparent.on("touchstart",(function(event){start=pointerEventToXY(event),startTop=Math.abs(parseInt(timebox.css("marginTop"),10))})),timeboxparent.on("touchmove",(function(event){if(start){event.preventDefault();var coord=pointerEventToXY(event);timeboxparent.trigger("scroll_element.xdsoft_scroller",[(startTop-(coord.y-start.y))/(height-parentHeight)])}})),timeboxparent.on("touchend touchcancel",(function(){start=!1,startTop=0}))),timeboxparent.trigger("resize_scroll.xdsoft_scroller",[percent])):timeboxparent.find(".xdsoft_scrollbar").hide()}))},$.fn.datetimepicker=function(opt,opt2){var result=this,KEY0=48,KEY9=57,_KEY0=96,_KEY9=105,CTRLKEY=17,CMDKEY=91,DEL=46,ENTER=13,ESC=27,BACKSPACE=8,ARROWLEFT=37,ARROWUP=38,ARROWRIGHT=39,ARROWDOWN=40,TAB=9,F5=116,AKEY=65,CKEY=67,VKEY=86,ZKEY=90,YKEY=89,ctrlDown=!1,cmdDown=!1,options=$.isPlainObject(opt)||!opt?$.extend(!0,{},default_options,opt):$.extend(!0,{},default_options),lazyInitTimer=0,createDateTimePicker,destroyDateTimePicker,lazyInit=function(input){input.on("open.xdsoft focusin.xdsoft mousedown.xdsoft touchstart",(function initOnActionCallback(){input.is(":disabled")||input.data("xdsoft_datetimepicker")||(clearTimeout(lazyInitTimer),lazyInitTimer=setTimeout((function(){input.data("xdsoft_datetimepicker")||createDateTimePicker(input),input.off("open.xdsoft focusin.xdsoft mousedown.xdsoft touchstart",initOnActionCallback).trigger("open.xdsoft")}),100))}))};return createDateTimePicker=function(input){var datetimepicker=$('<div class="xdsoft_datetimepicker xdsoft_noselect"></div>'),xdsoft_copyright=$('<div class="xdsoft_copyright"><a target="_blank" href="http://xdsoft.net/jqplugins/datetimepicker/">xdsoft.net</a></div>'),datepicker=$('<div class="xdsoft_datepicker active"></div>'),month_picker=$('<div class="xdsoft_monthpicker"><button type="button" class="xdsoft_prev"></button><button type="button" class="xdsoft_today_button"></button><div class="xdsoft_label xdsoft_month"><span></span><i></i></div><div class="xdsoft_label xdsoft_year"><span></span><i></i></div><button type="button" class="xdsoft_next"></button></div>'),calendar=$('<div class="xdsoft_calendar"></div>'),timepicker=$('<div class="xdsoft_timepicker active"><button type="button" class="xdsoft_prev"></button><div class="xdsoft_time_box"></div><button type="button" class="xdsoft_next"></button></div>'),timeboxparent=timepicker.find(".xdsoft_time_box").eq(0),timebox=$('<div class="xdsoft_time_variant"></div>'),applyButton=$('<button type="button" class="xdsoft_save_selected blue-gradient-button">Save Selected</button>'),monthselect=$('<div class="xdsoft_select xdsoft_monthselect"><div></div></div>'),yearselect=$('<div class="xdsoft_select xdsoft_yearselect"><div></div></div>'),triggerAfterOpen=!1,XDSoft_datetime,xchangeTimer,timerclick,current_time_index,setPos,timer=0,_xdsoft_datetime,forEachAncestorOf;options.id&&datetimepicker.attr("id",options.id),options.style&&datetimepicker.attr("style",options.style),options.weeks&&datetimepicker.addClass("xdsoft_showweeks"),options.rtl&&datetimepicker.addClass("xdsoft_rtl"),datetimepicker.addClass("xdsoft_"+options.theme),datetimepicker.addClass(options.className),month_picker.find(".xdsoft_month span").after(monthselect),month_picker.find(".xdsoft_year span").after(yearselect),month_picker.find(".xdsoft_month,.xdsoft_year").on("touchstart mousedown.xdsoft",(function(event){var select=$(this).find(".xdsoft_select").eq(0),val=0,top=0,visible=select.is(":visible"),items,i;for(month_picker.find(".xdsoft_select").hide(),_xdsoft_datetime.currentTime&&(val=_xdsoft_datetime.currentTime[$(this).hasClass("xdsoft_month")?"getMonth":"getFullYear"]()),select[visible?"hide":"show"](),items=select.find("div.xdsoft_option"),i=0;i<items.length&&items.eq(i).data("value")!==val;i+=1)top+=items[0].offsetHeight;return select.xdsoftScroller(options,top/(select.children()[0].offsetHeight-select[0].clientHeight)),event.stopPropagation(),!1}));var handleTouchMoved=function(event){var evt=event.originalEvent,touchPosition=evt.touches?evt.touches[0]:evt;this.touchStartPosition=this.touchStartPosition||touchPosition;var xMovement=Math.abs(this.touchStartPosition.clientX-touchPosition.clientX),yMovement=Math.abs(this.touchStartPosition.clientY-touchPosition.clientY),distance;Math.sqrt(xMovement*xMovement+yMovement*yMovement)>options.touchMovedThreshold&&(this.touchMoved=!0)};function getCurrentValue(){var ct=!1,time;return options.startDate?ct=_xdsoft_datetime.strToDate(options.startDate):(ct=options.value||(input&&input.val&&input.val()?input.val():""))?(ct=_xdsoft_datetime.strToDateTime(ct),options.yearOffset&&(ct=new Date(ct.getFullYear()-options.yearOffset,ct.getMonth(),ct.getDate(),ct.getHours(),ct.getMinutes(),ct.getSeconds(),ct.getMilliseconds()))):options.defaultDate&&(ct=_xdsoft_datetime.strToDateTime(options.defaultDate),options.defaultTime&&(time=_xdsoft_datetime.strtotime(options.defaultTime),ct.setHours(time.getHours()),ct.setMinutes(time.getMinutes()))),ct&&_xdsoft_datetime.isValidDate(ct)?datetimepicker.data("changed",!0):ct="",ct||0}function setMask(options){var isValidValue=function(mask,value){var reg=mask.replace(/([\[\]\/\{\}\(\)\-\.\+]{1})/g,"\\$1").replace(/_/g,"{digit+}").replace(/([0-9]{1})/g,"{digit$1}").replace(/\{digit([0-9]{1})\}/g,"[0-$1_]{1}").replace(/\{digit[\+]\}/g,"[0-9_]{1}");return new RegExp(reg).test(value)},getCaretPos=function(input){try{var range;if(options.ownerDocument.selection&&options.ownerDocument.selection.createRange)return options.ownerDocument.selection.createRange().getBookmark().charCodeAt(2)-2;if(input.setSelectionRange)return input.selectionStart}catch(e){return 0}},setCaretPos=function(node,pos){if(!(node="string"==typeof node||node instanceof String?options.ownerDocument.getElementById(node):node))return!1;if(node.createTextRange){var textRange=node.createTextRange();return textRange.collapse(!0),textRange.moveEnd("character",pos),textRange.moveStart("character",pos),textRange.select(),!0}return!!node.setSelectionRange&&(node.setSelectionRange(pos,pos),!0)};options.mask&&input.off("keydown.xdsoft"),!0===options.mask&&(dateHelper.formatMask?options.mask=dateHelper.formatMask(options.format):options.mask=options.format.replace(/Y/g,"9999").replace(/F/g,"9999").replace(/m/g,"19").replace(/d/g,"39").replace(/H/g,"29").replace(/i/g,"59").replace(/s/g,"59")),"string"===$.type(options.mask)&&(isValidValue(options.mask,input.val())||(input.val(options.mask.replace(/[0-9]/g,"_")),setCaretPos(input[0],0)),input.on("paste.xdsoft",(function(event){var clipboardData,pastedData=(event.clipboardData||event.originalEvent.clipboardData||window.clipboardData).getData("text"),val=this.value,pos=this.selectionStart,valueBeforeCursor=val.substr(0,pos),valueAfterPaste=val.substr(pos+pastedData.length);return val=valueBeforeCursor+pastedData+valueAfterPaste,pos+=pastedData.length,isValidValue(options.mask,val)?(this.value=val,setCaretPos(this,pos)):""===$.trim(val)?this.value=options.mask.replace(/[0-9]/g,"_"):input.trigger("error_input.xdsoft"),event.preventDefault(),!1})),input.on("keydown.xdsoft",(function(event){var val=this.value,key=event.which,pos=this.selectionStart,selEnd=this.selectionEnd,hasSel=pos!==selEnd,digit;if(key>=48&&key<=57||key>=96&&key<=105||8===key||46===key){for(digit=8===key||46===key?"_":String.fromCharCode(96<=key&&key<=105?key-48:key),8===key&&pos&&!hasSel&&(pos-=1);;){var maskValueAtCurPos=options.mask.substr(pos,1),posShorterThanMaskLength=pos<options.mask.length,posGreaterThanZero=pos>0,notNumberOrPlaceholder,curPosOnSep,continueMovingPosition;if(!(/[^0-9_]/.test(maskValueAtCurPos)&&posShorterThanMaskLength&&posGreaterThanZero))break;pos+=8!==key||hasSel?1:-1}if(event.metaKey&&(pos=0,hasSel=!0),hasSel){var selLength=selEnd-pos,defaultBlank=options.mask.replace(/[0-9]/g,"_"),defaultBlankSelectionReplacement,selReplacementRemainder=defaultBlank.substr(pos,selLength).substr(1),valueBeforeSel=val.substr(0,pos),insertChars=digit+selReplacementRemainder,charsAfterSelection=val.substr(pos+selLength);val=valueBeforeSel+insertChars+charsAfterSelection}else{var valueBeforeCursor=val.substr(0,pos),insertChar=digit,valueAfterNextChar=val.substr(pos+1);val=valueBeforeCursor+insertChar+valueAfterNextChar}if(""===$.trim(val))val=defaultBlank;else if(pos===options.mask.length)return event.preventDefault(),!1;for(pos+=8===key?0:1;/[^0-9_]/.test(options.mask.substr(pos,1))&&pos<options.mask.length&&pos>0;)pos+=8===key?0:1;isValidValue(options.mask,val)?(this.value=val,setCaretPos(this,pos)):""===$.trim(val)?this.value=options.mask.replace(/[0-9]/g,"_"):input.trigger("error_input.xdsoft")}else if(-1!==[AKEY,CKEY,VKEY,ZKEY,YKEY].indexOf(key)&&ctrlDown||-1!==[ESC,ARROWUP,ARROWDOWN,ARROWLEFT,ARROWRIGHT,F5,CTRLKEY,TAB,ENTER].indexOf(key))return!0;return event.preventDefault(),!1})))}month_picker.find(".xdsoft_select").xdsoftScroller(options).on("touchstart mousedown.xdsoft",(function(event){var evt=event.originalEvent;this.touchMoved=!1,this.touchStartPosition=evt.touches?evt.touches[0]:evt,event.stopPropagation(),event.preventDefault()})).on("touchmove",".xdsoft_option",handleTouchMoved).on("touchend mousedown.xdsoft",".xdsoft_option",(function(){if(!this.touchMoved){void 0!==_xdsoft_datetime.currentTime&&null!==_xdsoft_datetime.currentTime||(_xdsoft_datetime.currentTime=_xdsoft_datetime.now());var year=_xdsoft_datetime.currentTime.getFullYear();_xdsoft_datetime&&_xdsoft_datetime.currentTime&&_xdsoft_datetime.currentTime[$(this).parent().parent().hasClass("xdsoft_monthselect")?"setMonth":"setFullYear"]($(this).data("value")),$(this).parent().parent().hide(),datetimepicker.trigger("xchange.xdsoft"),options.onChangeMonth&&$.isFunction(options.onChangeMonth)&&options.onChangeMonth.call(datetimepicker,_xdsoft_datetime.currentTime,datetimepicker.data("input")),year!==_xdsoft_datetime.currentTime.getFullYear()&&$.isFunction(options.onChangeYear)&&options.onChangeYear.call(datetimepicker,_xdsoft_datetime.currentTime,datetimepicker.data("input"))}})),datetimepicker.getValue=function(){return _xdsoft_datetime.getCurrentTime()},datetimepicker.setOptions=function(_options){var highlightedDates={};options=$.extend(!0,{},options,_options),_options.allowTimes&&$.isArray(_options.allowTimes)&&_options.allowTimes.length&&(options.allowTimes=$.extend(!0,[],_options.allowTimes)),_options.weekends&&$.isArray(_options.weekends)&&_options.weekends.length&&(options.weekends=$.extend(!0,[],_options.weekends)),_options.allowDates&&$.isArray(_options.allowDates)&&_options.allowDates.length&&(options.allowDates=$.extend(!0,[],_options.allowDates)),_options.allowDateRe&&"[object String]"===Object.prototype.toString.call(_options.allowDateRe)&&(options.allowDateRe=new RegExp(_options.allowDateRe)),_options.highlightedDates&&$.isArray(_options.highlightedDates)&&_options.highlightedDates.length&&($.each(_options.highlightedDates,(function(index,value){var splitData=$.map(value.split(","),$.trim),exDesc,hDate=new HighlightedDate(dateHelper.parseDate(splitData[0],options.formatDate),splitData[1],splitData[2]),keyDate=dateHelper.formatDate(hDate.date,options.formatDate);void 0!==highlightedDates[keyDate]?(exDesc=highlightedDates[keyDate].desc)&&exDesc.length&&hDate.desc&&hDate.desc.length&&(highlightedDates[keyDate].desc=exDesc+"\n"+hDate.desc):highlightedDates[keyDate]=hDate})),options.highlightedDates=$.extend(!0,[],highlightedDates)),_options.highlightedPeriods&&$.isArray(_options.highlightedPeriods)&&_options.highlightedPeriods.length&&(highlightedDates=$.extend(!0,[],options.highlightedDates),$.each(_options.highlightedPeriods,(function(index,value){var dateTest,dateEnd,desc,hDate,keyDate,exDesc,style;if($.isArray(value))dateTest=value[0],dateEnd=value[1],desc=value[2],style=value[3];else{var splitData=$.map(value.split(","),$.trim);dateTest=dateHelper.parseDate(splitData[0],options.formatDate),dateEnd=dateHelper.parseDate(splitData[1],options.formatDate),desc=splitData[2],style=splitData[3]}for(;dateTest<=dateEnd;)hDate=new HighlightedDate(dateTest,desc,style),keyDate=dateHelper.formatDate(dateTest,options.formatDate),dateTest.setDate(dateTest.getDate()+1),void 0!==highlightedDates[keyDate]?(exDesc=highlightedDates[keyDate].desc)&&exDesc.length&&hDate.desc&&hDate.desc.length&&(highlightedDates[keyDate].desc=exDesc+"\n"+hDate.desc):highlightedDates[keyDate]=hDate})),options.highlightedDates=$.extend(!0,[],highlightedDates)),_options.disabledDates&&$.isArray(_options.disabledDates)&&_options.disabledDates.length&&(options.disabledDates=$.extend(!0,[],_options.disabledDates)),_options.disabledWeekDays&&$.isArray(_options.disabledWeekDays)&&_options.disabledWeekDays.length&&(options.disabledWeekDays=$.extend(!0,[],_options.disabledWeekDays)),!options.open&&!options.opened||options.inline||input.trigger("open.xdsoft"),options.inline&&(triggerAfterOpen=!0,datetimepicker.addClass("xdsoft_inline"),input.after(datetimepicker).hide()),options.inverseButton&&(options.next="xdsoft_prev",options.prev="xdsoft_next"),options.datepicker?datepicker.addClass("active"):datepicker.removeClass("active"),options.timepicker?timepicker.addClass("active"):timepicker.removeClass("active"),options.value&&(_xdsoft_datetime.setCurrentTime(options.value),input&&input.val&&input.val(_xdsoft_datetime.str)),isNaN(options.dayOfWeekStart)?options.dayOfWeekStart=0:options.dayOfWeekStart=parseInt(options.dayOfWeekStart,10)%7,options.timepickerScrollbar||timeboxparent.xdsoftScroller(options,"hide"),options.minDate&&/^[\+\-](.*)$/.test(options.minDate)&&(options.minDate=dateHelper.formatDate(_xdsoft_datetime.strToDateTime(options.minDate),options.formatDate)),options.maxDate&&/^[\+\-](.*)$/.test(options.maxDate)&&(options.maxDate=dateHelper.formatDate(_xdsoft_datetime.strToDateTime(options.maxDate),options.formatDate)),options.minDateTime&&/^\+(.*)$/.test(options.minDateTime)&&(options.minDateTime=_xdsoft_datetime.strToDateTime(options.minDateTime).dateFormat(options.formatDate)),options.maxDateTime&&/^\+(.*)$/.test(options.maxDateTime)&&(options.maxDateTime=_xdsoft_datetime.strToDateTime(options.maxDateTime).dateFormat(options.formatDate)),applyButton.toggle(options.showApplyButton),month_picker.find(".xdsoft_today_button").css("visibility",options.todayButton?"visible":"hidden"),month_picker.find("."+options.prev).css("visibility",options.prevButton?"visible":"hidden"),month_picker.find("."+options.next).css("visibility",options.nextButton?"visible":"hidden"),setMask(options),options.validateOnBlur&&input.off("blur.xdsoft").on("blur.xdsoft",(function(){if(options.allowBlank&&(!$.trim($(this).val()).length||"string"==typeof options.mask&&$.trim($(this).val())===options.mask.replace(/[0-9]/g,"_")))$(this).val(null),datetimepicker.data("xdsoft_datetime").empty();else{var d=dateHelper.parseDate($(this).val(),options.format);if(d)$(this).val(dateHelper.formatDate(d,options.format));else{var splittedHours=+[$(this).val()[0],$(this).val()[1]].join(""),splittedMinutes=+[$(this).val()[2],$(this).val()[3]].join("");!options.datepicker&&options.timepicker&&splittedHours>=0&&splittedHours<24&&splittedMinutes>=0&&splittedMinutes<60?$(this).val([splittedHours,splittedMinutes].map((function(item){return item>9?item:"0"+item})).join(":")):$(this).val(dateHelper.formatDate(_xdsoft_datetime.now(),options.format))}datetimepicker.data("xdsoft_datetime").setCurrentTime($(this).val())}datetimepicker.trigger("changedatetime.xdsoft"),datetimepicker.trigger("close.xdsoft")})),options.dayOfWeekStartPrev=0===options.dayOfWeekStart?6:options.dayOfWeekStart-1,datetimepicker.trigger("xchange.xdsoft").trigger("afterOpen.xdsoft")},datetimepicker.data("options",options).on("touchstart mousedown.xdsoft",(function(event){return event.stopPropagation(),event.preventDefault(),yearselect.hide(),monthselect.hide(),!1})),timeboxparent.append(timebox),timeboxparent.xdsoftScroller(options),datetimepicker.on("afterOpen.xdsoft",(function(){timeboxparent.xdsoftScroller(options)})),datetimepicker.append(datepicker).append(timepicker),!0!==options.withoutCopyright&&datetimepicker.append(xdsoft_copyright),datepicker.append(month_picker).append(calendar).append(applyButton),options.insideParent?$(input).parent().append(datetimepicker):$(options.parentID).append(datetimepicker),_xdsoft_datetime=new(XDSoft_datetime=function(){var _this=this;_this.now=function(norecursion){var d=new Date,date,time;return!norecursion&&options.defaultDate&&(date=_this.strToDateTime(options.defaultDate),d.setFullYear(date.getFullYear()),d.setMonth(date.getMonth()),d.setDate(date.getDate())),d.setFullYear(d.getFullYear()),!norecursion&&options.defaultTime&&(time=_this.strtotime(options.defaultTime),d.setHours(time.getHours()),d.setMinutes(time.getMinutes()),d.setSeconds(time.getSeconds()),d.setMilliseconds(time.getMilliseconds())),d},_this.isValidDate=function(d){return"[object Date]"===Object.prototype.toString.call(d)&&!isNaN(d.getTime())},_this.setCurrentTime=function(dTime,requireValidDate){"string"==typeof dTime?_this.currentTime=_this.strToDateTime(dTime):_this.isValidDate(dTime)?_this.currentTime=dTime:dTime||requireValidDate||!options.allowBlank||options.inline?_this.currentTime=_this.now():_this.currentTime=null,datetimepicker.trigger("xchange.xdsoft")},_this.empty=function(){_this.currentTime=null},_this.getCurrentTime=function(){return _this.currentTime},_this.nextMonth=function(){void 0!==_this.currentTime&&null!==_this.currentTime||(_this.currentTime=_this.now());var month=_this.currentTime.getMonth()+1,year;return 12===month&&(_this.currentTime.setFullYear(_this.currentTime.getFullYear()+1),month=0),year=_this.currentTime.getFullYear(),_this.currentTime.setDate(Math.min(new Date(_this.currentTime.getFullYear(),month+1,0).getDate(),_this.currentTime.getDate())),_this.currentTime.setMonth(month),options.onChangeMonth&&$.isFunction(options.onChangeMonth)&&options.onChangeMonth.call(datetimepicker,_xdsoft_datetime.currentTime,datetimepicker.data("input")),year!==_this.currentTime.getFullYear()&&$.isFunction(options.onChangeYear)&&options.onChangeYear.call(datetimepicker,_xdsoft_datetime.currentTime,datetimepicker.data("input")),datetimepicker.trigger("xchange.xdsoft"),month},_this.prevMonth=function(){void 0!==_this.currentTime&&null!==_this.currentTime||(_this.currentTime=_this.now());var month=_this.currentTime.getMonth()-1;return-1===month&&(_this.currentTime.setFullYear(_this.currentTime.getFullYear()-1),month=11),_this.currentTime.setDate(Math.min(new Date(_this.currentTime.getFullYear(),month+1,0).getDate(),_this.currentTime.getDate())),_this.currentTime.setMonth(month),options.onChangeMonth&&$.isFunction(options.onChangeMonth)&&options.onChangeMonth.call(datetimepicker,_xdsoft_datetime.currentTime,datetimepicker.data("input")),datetimepicker.trigger("xchange.xdsoft"),month},_this.getWeekOfYear=function(datetime){if(options.onGetWeekOfYear&&$.isFunction(options.onGetWeekOfYear)){var week=options.onGetWeekOfYear.call(datetimepicker,datetime);if(void 0!==week)return week}var onejan=new Date(datetime.getFullYear(),0,1);return 4!==onejan.getDay()&&onejan.setMonth(0,1+(4-onejan.getDay()+7)%7),Math.ceil(((datetime-onejan)/864e5+onejan.getDay()+1)/7)},_this.strToDateTime=function(sDateTime){var tmpDate=[],timeOffset,currentTime;return sDateTime&&sDateTime instanceof Date&&_this.isValidDate(sDateTime)?sDateTime:((tmpDate=/^([+-]{1})(.*)$/.exec(sDateTime))&&(tmpDate[2]=dateHelper.parseDate(tmpDate[2],options.formatDate)),tmpDate&&tmpDate[2]?(timeOffset=tmpDate[2].getTime()-6e4*tmpDate[2].getTimezoneOffset(),currentTime=new Date(_this.now(!0).getTime()+parseInt(tmpDate[1]+"1",10)*timeOffset)):currentTime=sDateTime?dateHelper.parseDate(sDateTime,options.format):_this.now(),_this.isValidDate(currentTime)||(currentTime=_this.now()),currentTime)},_this.strToDate=function(sDate){if(sDate&&sDate instanceof Date&&_this.isValidDate(sDate))return sDate;var currentTime=sDate?dateHelper.parseDate(sDate,options.formatDate):_this.now(!0);return _this.isValidDate(currentTime)||(currentTime=_this.now(!0)),currentTime},_this.strtotime=function(sTime){if(sTime&&sTime instanceof Date&&_this.isValidDate(sTime))return sTime;var currentTime=sTime?dateHelper.parseDate(sTime,options.formatTime):_this.now(!0);return _this.isValidDate(currentTime)||(currentTime=_this.now(!0)),currentTime},_this.str=function(){var format=options.format;return options.yearOffset&&(format=(format=format.replace("Y",_this.currentTime.getFullYear()+options.yearOffset)).replace("y",String(_this.currentTime.getFullYear()+options.yearOffset).substring(2,4))),dateHelper.formatDate(_this.currentTime,format)},_this.currentTime=this.now()}),applyButton.on("touchend click",(function(e){e.preventDefault(),datetimepicker.data("changed",!0),_xdsoft_datetime.setCurrentTime(getCurrentValue()),input.val(_xdsoft_datetime.str()),datetimepicker.trigger("close.xdsoft")})),month_picker.find(".xdsoft_today_button").on("touchend mousedown.xdsoft",(function(){datetimepicker.data("changed",!0),_xdsoft_datetime.setCurrentTime(0,!0),datetimepicker.trigger("afterOpen.xdsoft")})).on("dblclick.xdsoft",(function(){var currentDate=_xdsoft_datetime.getCurrentTime(),minDate,maxDate;currentDate=new Date(currentDate.getFullYear(),currentDate.getMonth(),currentDate.getDate()),minDate=_xdsoft_datetime.strToDate(options.minDate),currentDate<(minDate=new Date(minDate.getFullYear(),minDate.getMonth(),minDate.getDate()))||(maxDate=_xdsoft_datetime.strToDate(options.maxDate),currentDate>(maxDate=new Date(maxDate.getFullYear(),maxDate.getMonth(),maxDate.getDate()))||(input.val(_xdsoft_datetime.str()),input.trigger("change"),datetimepicker.trigger("close.xdsoft")))})),month_picker.find(".xdsoft_prev,.xdsoft_next").on("touchend mousedown.xdsoft",(function(){var $this=$(this),timer=0,stop=!1;!function arguments_callee1(v){$this.hasClass(options.next)?_xdsoft_datetime.nextMonth():$this.hasClass(options.prev)&&_xdsoft_datetime.prevMonth(),options.monthChangeSpinner&&(stop||(timer=setTimeout(arguments_callee1,v||100)))}(500),$([options.ownerDocument.body,options.contentWindow]).on("touchend mouseup.xdsoft",(function arguments_callee2(){clearTimeout(timer),stop=!0,$([options.ownerDocument.body,options.contentWindow]).off("touchend mouseup.xdsoft",arguments_callee2)}))})),timepicker.find(".xdsoft_prev,.xdsoft_next").on("touchend mousedown.xdsoft",(function(){var $this=$(this),timer=0,stop=!1,period=110;!function arguments_callee4(v){var pheight=timeboxparent[0].clientHeight,height=timebox[0].offsetHeight,top=Math.abs(parseInt(timebox.css("marginTop"),10));$this.hasClass(options.next)&&height-pheight-options.timeHeightInTimePicker>=top?timebox.css("marginTop","-"+(top+options.timeHeightInTimePicker)+"px"):$this.hasClass(options.prev)&&top-options.timeHeightInTimePicker>=0&&timebox.css("marginTop","-"+(top-options.timeHeightInTimePicker)+"px"),timeboxparent.trigger("scroll_element.xdsoft_scroller",[Math.abs(parseInt(timebox[0].style.marginTop,10)/(height-pheight))]),period=period>10?10:period-10,stop||(timer=setTimeout(arguments_callee4,v||period))}(500),$([options.ownerDocument.body,options.contentWindow]).on("touchend mouseup.xdsoft",(function arguments_callee5(){clearTimeout(timer),stop=!0,$([options.ownerDocument.body,options.contentWindow]).off("touchend mouseup.xdsoft",arguments_callee5)}))})),xchangeTimer=0,datetimepicker.on("xchange.xdsoft",(function(event){clearTimeout(xchangeTimer),xchangeTimer=setTimeout((function(){void 0!==_xdsoft_datetime.currentTime&&null!==_xdsoft_datetime.currentTime||(_xdsoft_datetime.currentTime=_xdsoft_datetime.now());for(var table="",start=new Date(_xdsoft_datetime.currentTime.getFullYear(),_xdsoft_datetime.currentTime.getMonth(),1,12,0,0),i=0,j,today=_xdsoft_datetime.now(),maxDate=!1,minDate=!1,minDateTime=!1,maxDateTime=!1,hDate,day,d,y,m,w,classes=[],customDateSettings,newRow=!0,time="",h,line_time,description,maxDateTimeDay;start.getDay()!==options.dayOfWeekStart;)start.setDate(start.getDate()-1);for(table+="<table><thead><tr>",options.weeks&&(table+="<th></th>"),j=0;j<7;j+=1)table+="<th>"+options.i18n[globalLocale].dayOfWeekShort[(j+options.dayOfWeekStart)%7]+"</th>";for(table+="</tr></thead>",table+="<tbody>",!1!==options.maxDate&&(maxDate=_xdsoft_datetime.strToDate(options.maxDate),maxDate=new Date(maxDate.getFullYear(),maxDate.getMonth(),maxDate.getDate(),23,59,59,999)),!1!==options.minDate&&(minDate=_xdsoft_datetime.strToDate(options.minDate),minDate=new Date(minDate.getFullYear(),minDate.getMonth(),minDate.getDate())),!1!==options.minDateTime&&(minDateTime=_xdsoft_datetime.strToDate(options.minDateTime),minDateTime=new Date(minDateTime.getFullYear(),minDateTime.getMonth(),minDateTime.getDate(),minDateTime.getHours(),minDateTime.getMinutes(),minDateTime.getSeconds())),!1!==options.maxDateTime&&(maxDateTime=_xdsoft_datetime.strToDate(options.maxDateTime),maxDateTime=new Date(maxDateTime.getFullYear(),maxDateTime.getMonth(),maxDateTime.getDate(),maxDateTime.getHours(),maxDateTime.getMinutes(),maxDateTime.getSeconds())),!1!==maxDateTime&&(maxDateTimeDay=31*(12*maxDateTime.getFullYear()+maxDateTime.getMonth())+maxDateTime.getDate());i<_xdsoft_datetime.currentTime.countDaysInMonth()||start.getDay()!==options.dayOfWeekStart||_xdsoft_datetime.currentTime.getMonth()===start.getMonth();){classes=[],i+=1,day=start.getDay(),d=start.getDate(),y=start.getFullYear(),m=start.getMonth(),w=_xdsoft_datetime.getWeekOfYear(start),description="",classes.push("xdsoft_date"),customDateSettings=options.beforeShowDay&&$.isFunction(options.beforeShowDay.call)?options.beforeShowDay.call(datetimepicker,start):null,options.allowDateRe&&"[object RegExp]"===Object.prototype.toString.call(options.allowDateRe)&&(options.allowDateRe.test(dateHelper.formatDate(start,options.formatDate))||classes.push("xdsoft_disabled")),options.allowDates&&options.allowDates.length>0&&-1===options.allowDates.indexOf(dateHelper.formatDate(start,options.formatDate))&&classes.push("xdsoft_disabled");var currentDay=31*(12*start.getFullYear()+start.getMonth())+start.getDate();(!1!==maxDate&&start>maxDate||!1!==minDateTime&&start<minDateTime||!1!==minDate&&start<minDate||!1!==maxDateTime&&currentDay>maxDateTimeDay||customDateSettings&&!1===customDateSettings[0])&&classes.push("xdsoft_disabled"),-1!==options.disabledDates.indexOf(dateHelper.formatDate(start,options.formatDate))&&classes.push("xdsoft_disabled"),-1!==options.disabledWeekDays.indexOf(day)&&classes.push("xdsoft_disabled"),input.is("[disabled]")&&classes.push("xdsoft_disabled"),customDateSettings&&""!==customDateSettings[1]&&classes.push(customDateSettings[1]),_xdsoft_datetime.currentTime.getMonth()!==m&&classes.push("xdsoft_other_month"),(options.defaultSelect||datetimepicker.data("changed"))&&dateHelper.formatDate(_xdsoft_datetime.currentTime,options.formatDate)===dateHelper.formatDate(start,options.formatDate)&&classes.push("xdsoft_current"),dateHelper.formatDate(today,options.formatDate)===dateHelper.formatDate(start,options.formatDate)&&classes.push("xdsoft_today"),0!==start.getDay()&&6!==start.getDay()&&-1===options.weekends.indexOf(dateHelper.formatDate(start,options.formatDate))||classes.push("xdsoft_weekend"),void 0!==options.highlightedDates[dateHelper.formatDate(start,options.formatDate)]&&(hDate=options.highlightedDates[dateHelper.formatDate(start,options.formatDate)],classes.push(void 0===hDate.style?"xdsoft_highlighted_default":hDate.style),description=void 0===hDate.desc?"":hDate.desc),options.beforeShowDay&&$.isFunction(options.beforeShowDay)&&classes.push(options.beforeShowDay(start)),newRow&&(table+="<tr>",newRow=!1,options.weeks&&(table+="<th>"+w+"</th>")),table+='<td data-date="'+d+'" data-month="'+m+'" data-year="'+y+'" class="xdsoft_date xdsoft_day_of_week'+start.getDay()+" "+classes.join(" ")+'" title="'+description+'"><div>'+d+"</div></td>",start.getDay()===options.dayOfWeekStartPrev&&(table+="</tr>",newRow=!0),start.setDate(d+1)}table+="</tbody></table>",calendar.html(table),month_picker.find(".xdsoft_label span").eq(0).text(options.i18n[globalLocale].months[_xdsoft_datetime.currentTime.getMonth()]),month_picker.find(".xdsoft_label span").eq(1).text(_xdsoft_datetime.currentTime.getFullYear()+options.yearOffset),time="",h="",m="";var minTimeMinutesOfDay=0;if(!1!==options.minTime){var t=_xdsoft_datetime.strtotime(options.minTime);minTimeMinutesOfDay=60*t.getHours()+t.getMinutes()}var maxTimeMinutesOfDay=1440;if(!1!==options.maxTime){var t=_xdsoft_datetime.strtotime(options.maxTime);maxTimeMinutesOfDay=60*t.getHours()+t.getMinutes()}if(!1!==options.minDateTime){var t=_xdsoft_datetime.strToDateTime(options.minDateTime),currentDayIsMinDateTimeDay,m;if(dateHelper.formatDate(_xdsoft_datetime.currentTime,options.formatDate)===dateHelper.formatDate(t,options.formatDate))(m=60*t.getHours()+t.getMinutes())>minTimeMinutesOfDay&&(minTimeMinutesOfDay=m)}if(!1!==options.maxDateTime){var t=_xdsoft_datetime.strToDateTime(options.maxDateTime),currentDayIsMaxDateTimeDay,m;if(dateHelper.formatDate(_xdsoft_datetime.currentTime,options.formatDate)===dateHelper.formatDate(t,options.formatDate))(m=60*t.getHours()+t.getMinutes())<maxTimeMinutesOfDay&&(maxTimeMinutesOfDay=m)}if(line_time=function line_time(h,m){var now=_xdsoft_datetime.now(),current_time,isALlowTimesInit=options.allowTimes&&$.isArray(options.allowTimes)&&options.allowTimes.length;now.setHours(h),h=parseInt(now.getHours(),10),now.setMinutes(m),m=parseInt(now.getMinutes(),10),classes=[];var currentMinutesOfDay=60*h+m;(input.is("[disabled]")||currentMinutesOfDay>=maxTimeMinutesOfDay||currentMinutesOfDay<minTimeMinutesOfDay)&&classes.push("xdsoft_disabled"),(current_time=new Date(_xdsoft_datetime.currentTime)).setHours(parseInt(_xdsoft_datetime.currentTime.getHours(),10)),isALlowTimesInit||current_time.setMinutes(Math[options.roundTime](_xdsoft_datetime.currentTime.getMinutes()/options.step)*options.step),(options.initTime||options.defaultSelect||datetimepicker.data("changed"))&&current_time.getHours()===parseInt(h,10)&&(!isALlowTimesInit&&options.step>59||current_time.getMinutes()===parseInt(m,10))&&(options.defaultSelect||datetimepicker.data("changed")?classes.push("xdsoft_current"):options.initTime&&classes.push("xdsoft_init_time")),parseInt(today.getHours(),10)===parseInt(h,10)&&parseInt(today.getMinutes(),10)===parseInt(m,10)&&classes.push("xdsoft_today"),time+='<div class="xdsoft_time '+classes.join(" ")+'" data-hour="'+h+'" data-minute="'+m+'">'+dateHelper.formatDate(now,options.formatTime)+"</div>"},options.allowTimes&&$.isArray(options.allowTimes)&&options.allowTimes.length)for(i=0;i<options.allowTimes.length;i+=1)line_time(h=_xdsoft_datetime.strtotime(options.allowTimes[i]).getHours(),m=_xdsoft_datetime.strtotime(options.allowTimes[i]).getMinutes());else for(i=0,j=0;i<(options.hours12?12:24);i+=1)for(j=0;j<60;j+=options.step){var currentMinutesOfDay=60*i+j;currentMinutesOfDay<minTimeMinutesOfDay||(currentMinutesOfDay>=maxTimeMinutesOfDay||line_time(h=(i<10?"0":"")+i,m=(j<10?"0":"")+j))}for(timebox.html(time),opt="",i=parseInt(options.yearStart,10);i<=parseInt(options.yearEnd,10);i+=1)opt+='<div class="xdsoft_option '+(_xdsoft_datetime.currentTime.getFullYear()===i?"xdsoft_current":"")+'" data-value="'+i+'">'+(i+options.yearOffset)+"</div>";for(yearselect.children().eq(0).html(opt),i=parseInt(options.monthStart,10),opt="";i<=parseInt(options.monthEnd,10);i+=1)opt+='<div class="xdsoft_option '+(_xdsoft_datetime.currentTime.getMonth()===i?"xdsoft_current":"")+'" data-value="'+i+'">'+options.i18n[globalLocale].months[i]+"</div>";monthselect.children().eq(0).html(opt),$(datetimepicker).trigger("generate.xdsoft")}),10),event.stopPropagation()})).on("afterOpen.xdsoft",(function(){var classType,pheight,height,top;options.timepicker&&(timebox.find(".xdsoft_current").length?classType=".xdsoft_current":timebox.find(".xdsoft_init_time").length&&(classType=".xdsoft_init_time"),classType?(pheight=timeboxparent[0].clientHeight,(height=timebox[0].offsetHeight)-pheight<(top=timebox.find(classType).index()*options.timeHeightInTimePicker+1)&&(top=height-pheight),timeboxparent.trigger("scroll_element.xdsoft_scroller",[parseInt(top,10)/(height-pheight)])):timeboxparent.trigger("scroll_element.xdsoft_scroller",[0]))})),timerclick=0,calendar.on("touchend click.xdsoft","td",(function(xdevent){xdevent.stopPropagation(),timerclick+=1;var $this=$(this),currentTime=_xdsoft_datetime.currentTime;if(null==currentTime&&(_xdsoft_datetime.currentTime=_xdsoft_datetime.now(),currentTime=_xdsoft_datetime.currentTime),$this.hasClass("xdsoft_disabled"))return!1;currentTime.setDate(1),currentTime.setFullYear($this.data("year")),currentTime.setMonth($this.data("month")),currentTime.setDate($this.data("date")),datetimepicker.trigger("select.xdsoft",[currentTime]),input.val(_xdsoft_datetime.str()),options.onSelectDate&&$.isFunction(options.onSelectDate)&&options.onSelectDate.call(datetimepicker,_xdsoft_datetime.currentTime,datetimepicker.data("input"),xdevent),datetimepicker.data("changed",!0),datetimepicker.trigger("xchange.xdsoft"),datetimepicker.trigger("changedatetime.xdsoft"),(timerclick>1||!0===options.closeOnDateSelect||!1===options.closeOnDateSelect&&!options.timepicker)&&!options.inline&&datetimepicker.trigger("close.xdsoft"),setTimeout((function(){timerclick=0}),200)})),timebox.on("touchstart","div",(function(xdevent){this.touchMoved=!1})).on("touchmove","div",handleTouchMoved).on("touchend click.xdsoft","div",(function(xdevent){if(!this.touchMoved){xdevent.stopPropagation();var $this=$(this),currentTime=_xdsoft_datetime.currentTime;if(null==currentTime&&(_xdsoft_datetime.currentTime=_xdsoft_datetime.now(),currentTime=_xdsoft_datetime.currentTime),$this.hasClass("xdsoft_disabled"))return!1;currentTime.setHours($this.data("hour")),currentTime.setMinutes($this.data("minute")),datetimepicker.trigger("select.xdsoft",[currentTime]),datetimepicker.data("input").val(_xdsoft_datetime.str()),options.onSelectTime&&$.isFunction(options.onSelectTime)&&options.onSelectTime.call(datetimepicker,_xdsoft_datetime.currentTime,datetimepicker.data("input"),xdevent),datetimepicker.data("changed",!0),datetimepicker.trigger("xchange.xdsoft"),datetimepicker.trigger("changedatetime.xdsoft"),!0!==options.inline&&!0===options.closeOnTimeSelect&&datetimepicker.trigger("close.xdsoft")}})),datepicker.on("mousewheel.xdsoft",(function(event){return!options.scrollMonth||(event.deltaY<0?_xdsoft_datetime.nextMonth():_xdsoft_datetime.prevMonth(),!1)})),input.on("mousewheel.xdsoft",(function(event){return!options.scrollInput||(!options.datepicker&&options.timepicker?((current_time_index=timebox.find(".xdsoft_current").length?timebox.find(".xdsoft_current").eq(0).index():0)+event.deltaY>=0&&current_time_index+event.deltaY<timebox.children().length&&(current_time_index+=event.deltaY),timebox.children().eq(current_time_index).length&&timebox.children().eq(current_time_index).trigger("mousedown"),!1):options.datepicker&&!options.timepicker?(datepicker.trigger(event,[event.deltaY,event.deltaX,event.deltaY]),input.val&&input.val(_xdsoft_datetime.str()),datetimepicker.trigger("changedatetime.xdsoft"),!1):void 0)})),datetimepicker.on("changedatetime.xdsoft",(function(event){if(options.onChangeDateTime&&$.isFunction(options.onChangeDateTime)){var $input=datetimepicker.data("input");options.onChangeDateTime.call(datetimepicker,_xdsoft_datetime.currentTime,$input,event),delete options.value,$input.trigger("change")}})).on("generate.xdsoft",(function(){options.onGenerate&&$.isFunction(options.onGenerate)&&options.onGenerate.call(datetimepicker,_xdsoft_datetime.currentTime,datetimepicker.data("input")),triggerAfterOpen&&(datetimepicker.trigger("afterOpen.xdsoft"),triggerAfterOpen=!1)})).on("click.xdsoft",(function(xdevent){xdevent.stopPropagation()})),current_time_index=0,forEachAncestorOf=function(node,callback){do{if(!(node=node.parentNode)||!1===callback(node))break}while("HTML"!==node.nodeName)},setPos=function(){var dateInputOffset,dateInputElem,verticalPosition,left,position,datetimepickerElem,dateInputHasFixedAncestor,$dateInput,windowWidth,verticalAnchorEdge,datetimepickerCss,windowHeight,windowScrollTop;if(dateInputOffset=($dateInput=datetimepicker.data("input")).offset(),dateInputElem=$dateInput[0],verticalAnchorEdge="top",verticalPosition=dateInputOffset.top+dateInputElem.offsetHeight-1,left=dateInputOffset.left,position="absolute",windowWidth=$(options.contentWindow).width(),windowHeight=$(options.contentWindow).height(),windowScrollTop=$(options.contentWindow).scrollTop(),options.ownerDocument.documentElement.clientWidth-dateInputOffset.left<datepicker.parent().outerWidth(!0)){var diff=datepicker.parent().outerWidth(!0)-dateInputElem.offsetWidth;left-=diff}"rtl"===$dateInput.parent().css("direction")&&(left-=datetimepicker.outerWidth()-$dateInput.outerWidth()),options.fixed?(verticalPosition-=windowScrollTop,left-=$(options.contentWindow).scrollLeft(),position="fixed"):(dateInputHasFixedAncestor=!1,forEachAncestorOf(dateInputElem,(function(ancestorNode){return null!==ancestorNode&&("fixed"===options.contentWindow.getComputedStyle(ancestorNode).getPropertyValue("position")?(dateInputHasFixedAncestor=!0,!1):void 0)})),dateInputHasFixedAncestor&&!options.insideParent?(position="fixed",verticalPosition+datetimepicker.outerHeight()>windowHeight+windowScrollTop?(verticalAnchorEdge="bottom",verticalPosition=windowHeight+windowScrollTop-dateInputOffset.top):verticalPosition-=windowScrollTop):verticalPosition+datetimepicker[0].offsetHeight>windowHeight+windowScrollTop&&(verticalPosition=dateInputOffset.top-datetimepicker[0].offsetHeight+1),verticalPosition<0&&(verticalPosition=0),left+dateInputElem.offsetWidth>windowWidth&&(left=windowWidth-dateInputElem.offsetWidth)),datetimepickerElem=datetimepicker[0],forEachAncestorOf(datetimepickerElem,(function(ancestorNode){var ancestorNodePosition;if("relative"===(ancestorNodePosition=options.contentWindow.getComputedStyle(ancestorNode).getPropertyValue("position"))&&windowWidth>=ancestorNode.offsetWidth)return left-=(windowWidth-ancestorNode.offsetWidth)/2,!1})),datetimepickerCss={position:position,left:options.insideParent?dateInputElem.offsetLeft:left,top:"",bottom:""},options.insideParent?datetimepickerCss[verticalAnchorEdge]=dateInputElem.offsetTop+dateInputElem.offsetHeight:datetimepickerCss[verticalAnchorEdge]=verticalPosition,datetimepicker.css(datetimepickerCss)},datetimepicker.on("open.xdsoft",(function(event){var onShow=!0;options.onShow&&$.isFunction(options.onShow)&&(onShow=options.onShow.call(datetimepicker,_xdsoft_datetime.currentTime,datetimepicker.data("input"),event)),!1!==onShow&&(datetimepicker.show(),setPos(),$(options.contentWindow).off("resize.xdsoft",setPos).on("resize.xdsoft",setPos),options.closeOnWithoutClick&&$([options.ownerDocument.body,options.contentWindow]).on("touchstart mousedown.xdsoft",(function arguments_callee6(){datetimepicker.trigger("close.xdsoft"),$([options.ownerDocument.body,options.contentWindow]).off("touchstart mousedown.xdsoft",arguments_callee6)})))})).on("close.xdsoft",(function(event){var onClose=!0;month_picker.find(".xdsoft_month,.xdsoft_year").find(".xdsoft_select").hide(),options.onClose&&$.isFunction(options.onClose)&&(onClose=options.onClose.call(datetimepicker,_xdsoft_datetime.currentTime,datetimepicker.data("input"),event)),!1===onClose||options.opened||options.inline||datetimepicker.hide(),event.stopPropagation()})).on("toggle.xdsoft",(function(){datetimepicker.is(":visible")?datetimepicker.trigger("close.xdsoft"):datetimepicker.trigger("open.xdsoft")})).data("input",input),timer=0,datetimepicker.data("xdsoft_datetime",_xdsoft_datetime),datetimepicker.setOptions(options),_xdsoft_datetime.setCurrentTime(getCurrentValue()),input.data("xdsoft_datetimepicker",datetimepicker).on("open.xdsoft focusin.xdsoft mousedown.xdsoft touchstart",(function(){input.is(":disabled")||input.data("xdsoft_datetimepicker").is(":visible")&&options.closeOnInputClick||options.openOnFocus&&(clearTimeout(timer),timer=setTimeout((function(){input.is(":disabled")||(triggerAfterOpen=!0,_xdsoft_datetime.setCurrentTime(getCurrentValue(),!0),options.mask&&setMask(options),datetimepicker.trigger("open.xdsoft"))}),100))})).on("keydown.xdsoft",(function(event){var elementSelector,key=event.which;return-1!==[ENTER].indexOf(key)&&options.enterLikeTab?(elementSelector=$("input:visible,textarea:visible,button:visible,a:visible"),datetimepicker.trigger("close.xdsoft"),elementSelector.eq(elementSelector.index(this)+1).focus(),!1):-1!==[TAB].indexOf(key)?(datetimepicker.trigger("close.xdsoft"),!0):void 0})).on("blur.xdsoft",(function(){datetimepicker.trigger("close.xdsoft")}))},destroyDateTimePicker=function(input){var datetimepicker=input.data("xdsoft_datetimepicker");datetimepicker&&(datetimepicker.data("xdsoft_datetime",null),datetimepicker.remove(),input.data("xdsoft_datetimepicker",null).off(".xdsoft"),$(options.contentWindow).off("resize.xdsoft"),$([options.contentWindow,options.ownerDocument.body]).off("mousedown.xdsoft touchstart"),input.unmousewheel&&input.unmousewheel())},$(options.ownerDocument).off("keydown.xdsoftctrl keyup.xdsoftctrl").off("keydown.xdsoftcmd keyup.xdsoftcmd").on("keydown.xdsoftctrl",(function(e){e.keyCode===CTRLKEY&&(ctrlDown=!0)})).on("keyup.xdsoftctrl",(function(e){e.keyCode===CTRLKEY&&(ctrlDown=!1)})).on("keydown.xdsoftcmd",(function(e){91===e.keyCode&&(cmdDown=!0)})).on("keyup.xdsoftcmd",(function(e){91===e.keyCode&&(cmdDown=!1)})),this.each((function(){var datetimepicker=$(this).data("xdsoft_datetimepicker"),$input;if(datetimepicker){if("string"===$.type(opt))switch(opt){case"show":$(this).select().focus(),datetimepicker.trigger("open.xdsoft");break;case"hide":datetimepicker.trigger("close.xdsoft");break;case"toggle":datetimepicker.trigger("toggle.xdsoft");break;case"destroy":destroyDateTimePicker($(this));break;case"reset":this.value=this.defaultValue,this.value&&datetimepicker.data("xdsoft_datetime").isValidDate(dateHelper.parseDate(this.value,options.format))||datetimepicker.data("changed",!1),datetimepicker.data("xdsoft_datetime").setCurrentTime(this.value);break;case"validate":($input=datetimepicker.data("input")).trigger("blur.xdsoft");break;default:datetimepicker[opt]&&$.isFunction(datetimepicker[opt])&&(result=datetimepicker[opt](opt2))}else datetimepicker.setOptions(opt);return 0}"string"!==$.type(opt)&&(!options.lazyInit||options.open||options.inline?createDateTimePicker($(this)):lazyInit($(this)))})),result},$.fn.datetimepicker.defaults=default_options};!function(factory){"function"==typeof define&&define.amd?define(["jquery","jquery-mousewheel"],factory):"object"==typeof exports?module.exports=factory(require("jquery")):factory(jQuery)}(datetimepickerFactory),
/*!
 * jQuery Mousewheel 3.1.13
 *
 * Copyright jQuery Foundation and other contributors
 * Released under the MIT license
 * http://jquery.org/license
 */
function(factory){"function"==typeof define&&define.amd?define(["jquery"],factory):"object"==typeof exports?module.exports=factory:factory(jQuery)}((function($){var toFix=["wheel","mousewheel","DOMMouseScroll","MozMousePixelScroll"],toBind="onwheel"in document||document.documentMode>=9?["wheel"]:["mousewheel","DomMouseScroll","MozMousePixelScroll"],slice=Array.prototype.slice,nullLowestDeltaTimeout,lowestDelta;if($.event.fixHooks)for(var i=toFix.length;i;)$.event.fixHooks[toFix[--i]]=$.event.mouseHooks;var special=$.event.special.mousewheel={version:"3.1.12",setup:function(){if(this.addEventListener)for(var i=toBind.length;i;)this.addEventListener(toBind[--i],handler,!1);else this.onmousewheel=handler;$.data(this,"mousewheel-line-height",special.getLineHeight(this)),$.data(this,"mousewheel-page-height",special.getPageHeight(this))},teardown:function(){if(this.removeEventListener)for(var i=toBind.length;i;)this.removeEventListener(toBind[--i],handler,!1);else this.onmousewheel=null;$.removeData(this,"mousewheel-line-height"),$.removeData(this,"mousewheel-page-height")},getLineHeight:function(elem){var $elem=$(elem),$parent=$elem["offsetParent"in $.fn?"offsetParent":"parent"]();return $parent.length||($parent=$("body")),parseInt($parent.css("fontSize"),10)||parseInt($elem.css("fontSize"),10)||16},getPageHeight:function(elem){return $(elem).height()},settings:{adjustOldDeltas:!0,normalizeOffset:!0}};function handler(event){var orgEvent=event||window.event,args=slice.call(arguments,1),delta=0,deltaX=0,deltaY=0,absDelta=0,offsetX=0,offsetY=0;if((event=$.event.fix(orgEvent)).type="mousewheel","detail"in orgEvent&&(deltaY=-1*orgEvent.detail),"wheelDelta"in orgEvent&&(deltaY=orgEvent.wheelDelta),"wheelDeltaY"in orgEvent&&(deltaY=orgEvent.wheelDeltaY),"wheelDeltaX"in orgEvent&&(deltaX=-1*orgEvent.wheelDeltaX),"axis"in orgEvent&&orgEvent.axis===orgEvent.HORIZONTAL_AXIS&&(deltaX=-1*deltaY,deltaY=0),delta=0===deltaY?deltaX:deltaY,"deltaY"in orgEvent&&(delta=deltaY=-1*orgEvent.deltaY),"deltaX"in orgEvent&&(deltaX=orgEvent.deltaX,0===deltaY&&(delta=-1*deltaX)),0!==deltaY||0!==deltaX){if(1===orgEvent.deltaMode){var lineHeight=$.data(this,"mousewheel-line-height");delta*=lineHeight,deltaY*=lineHeight,deltaX*=lineHeight}else if(2===orgEvent.deltaMode){var pageHeight=$.data(this,"mousewheel-page-height");delta*=pageHeight,deltaY*=pageHeight,deltaX*=pageHeight}if(absDelta=Math.max(Math.abs(deltaY),Math.abs(deltaX)),(!lowestDelta||absDelta<lowestDelta)&&(lowestDelta=absDelta,shouldAdjustOldDeltas(orgEvent,absDelta)&&(lowestDelta/=40)),shouldAdjustOldDeltas(orgEvent,absDelta)&&(delta/=40,deltaX/=40,deltaY/=40),delta=Math[delta>=1?"floor":"ceil"](delta/lowestDelta),deltaX=Math[deltaX>=1?"floor":"ceil"](deltaX/lowestDelta),deltaY=Math[deltaY>=1?"floor":"ceil"](deltaY/lowestDelta),special.settings.normalizeOffset&&this.getBoundingClientRect){var boundingRect=this.getBoundingClientRect();offsetX=event.clientX-boundingRect.left,offsetY=event.clientY-boundingRect.top}return event.deltaX=deltaX,event.deltaY=deltaY,event.deltaFactor=lowestDelta,event.offsetX=offsetX,event.offsetY=offsetY,event.deltaMode=0,args.unshift(event,delta,deltaX,deltaY),nullLowestDeltaTimeout&&clearTimeout(nullLowestDeltaTimeout),nullLowestDeltaTimeout=setTimeout(nullLowestDelta,200),($.event.dispatch||$.event.handle).apply(this,args)}}function nullLowestDelta(){lowestDelta=null}function shouldAdjustOldDeltas(orgEvent,absDelta){return special.settings.adjustOldDeltas&&"mousewheel"===orgEvent.type&&absDelta%120==0}$.fn.extend({mousewheel:function(fn){return fn?this.bind("mousewheel",fn):this.trigger("mousewheel")},unmousewheel:function(fn){return this.unbind("mousewheel",fn)}})}));